﻿//////// Classes liées à l'initialisation
//////// Init's classes
// Classe 'WinIni' pour gestion fenetre d'init.;
// Class 'WinIni' for init.'s window
// Constructeur WinIni
function WinIni() {
}
WinIni.prototype = new Window();
WinIni.prototype.assignLabelsDefault = function(labels) {	
	this.oLabel_language.text = labels.initLanguage;
	this.oLabel_title.text = labels.initTitle;
	this.oLabel_comment.text = labels.initComment;
	this.oLabel_warning.text = labels.initWarning;
	
	this.oLang_buttons.oFrench.oLabel.text = labels.initFrench;
	this.oLang_buttons.oEnglish.oLabel.text = labels.initEnglish;
	this.oLang_buttons.oSpanish.oLabel.text = labels.initSpanish;
	this.oLang_buttons.oPt.oLabel.text = labels.initPt;
	this.oLang_buttons.oIt.oLabel.text = labels.initIt;
	this.oLabel_displayWin.text = labels.initDisplay;
	this.oValid.oLabel.text = labels.initValid;
	this.oMsgWin._visible = false ;
};
WinIni.prototype.showLangMsg = function(lg,isVisible,labels) {
	// the omsgwin is removing : I've to make this code again
	// using the help's package.
	switch (lg) {
	case "en" :
		this.oMsgWin.otx.html =true ;
		this.oMsgWin.otx.htmlText = labels.initEnMsg ;
		break;
	case "sp" :
		this.oMsgWin.otx.html =true ;
		this.oMsgWin.otx.htmlText = labels.initSpMsg ;
		break;
	default :
		// impossible !!
	}
	this.oMsgWin._visible = isVisible ;
}
WinIni.prototype.initButtons = function(lg) {
	this.oLang_buttons.language = lg;
	switch (lg) {
	case "fr" :
		this.oLang_buttons.oFrench.gotoAndStop("up");
		break;
	case "en" :
		this.oLang_buttons.oEnglish.gotoAndStop("up");
		break;
	case "sp" :
		this.oLang_buttons.oSpanish.gotoAndStop("up");
		break;
	case "pt" :
		this.oLang_buttons.oPt.gotoAndStop("up");
		break;
	case "it" :
		this.oLang_buttons.oIt.gotoAndStop("up");
		break;
	default :
		// impossible !!
	}
};


WinIni.prototype.initParameters = function(disp) {
	this.oDisplay.setValue(!disp);
	
};
WinIni.prototype.downLangButtons = function() {
	for (var o in this.oLang_buttons) {
		this.oLang_buttons[o].gotoAndStop("out");
	}
};

WinIni.prototype.assignFunctionsOnEvents = function(objScript) {
	//lang. buttons
	var o = this.oLang_buttons;
	var wini = this;
	//french
	o.oFrench.onRollOver = function() {
		wini.downLangButtons();
		this.gotoAndStop("over");
	};
	o.oFrench.onRollOut = function() {
		wini.downLangButtons();
		this.gotoAndStop("out");
		wini.initButtons(this._parent.language);
	};
	o.oFrench.onRelease = function() {
		wini.downLangButtons();
		this.gotoAndStop("up");
		this._parent.language = "fr";
		this._parent._parent.oValid.onRelease() ;
	};
	// english
	o.oEnglish.onRollOver = function() {
		wini.showLangMsg("en",true,objScript) ;
		wini.downLangButtons();
		this.gotoAndStop("over");
	};
	o.oEnglish.onRollOut = function() {		
		wini.showLangMsg("en",false,objScript) ;
		wini.downLangButtons();
		this.gotoAndStop("out");
		wini.initButtons(this._parent.language);
	};
	o.oEnglish.onRelease = function() {
		wini.downLangButtons();
		this.gotoAndStop("up");
		this._parent.language = "en";
		this._parent._parent.oValid.onRelease() ;
	};
	// Spanish
	o.oSpanish.onRollOver = function() {
		wini.showLangMsg("sp",true,objScript) ;
		wini.downLangButtons();
		this.gotoAndStop("over");
	};
	o.oSpanish.onRollOut = function() {
		wini.showLangMsg("sp",false,objScript) ;
		wini.downLangButtons();
		this.gotoAndStop("out");
		wini.initButtons(this._parent.language);
	};
	o.oSpanish.onRelease = function() {
		wini.downLangButtons();
		this.gotoAndStop("up");
		this._parent.language = "sp";
		this._parent._parent.oValid.onRelease() ;
	};
	
	// Portuguese
	o.oPt.onRollOver = function() {
		wini.downLangButtons();
		this.gotoAndStop("over");
	};
	o.oPt.onRollOut = function() {
		wini.downLangButtons();
		this.gotoAndStop("out");
		wini.initButtons(this._parent.language);
	};
	o.oPt.onRelease = function() {
		wini.downLangButtons();
		this.gotoAndStop("up");
		this._parent.language = "pt";
		this._parent._parent.oValid.onRelease() ;
	};
// Italian
	o.oIt.onRollOver = function() {
		wini.downLangButtons();
		this.gotoAndStop("over");
	};
	o.oIt.onRollOut = function() {
		wini.downLangButtons();
		this.gotoAndStop("out");
		wini.initButtons(this._parent.language);
	};
	o.oIt.onRelease = function() {
		wini.downLangButtons();
		this.gotoAndStop("up");
		this._parent.language = "it";
		this._parent._parent.oValid.onRelease() ;
	};

	this.oValid.bebutton("over", "out", "over");
	this.oValid.onRelease = function() {
		objScript.onEndWinIni(!this._parent.oDisplay.getValue(),
							   this._parent.oLang_buttons.language							   
							   );
		
		this._parent.closeWin();
	};
	
	this.setEnterDefaultAction(this.oValid);
};