﻿// tables's script class
function ScriptTable(listWinName, updWinName) {
	this.listWinName = listWinName;
	this.updWinName = updWinName;
	
}
ScriptTable.prototype = new SuperScriptUpd();
// tables's list window 
ScriptTable.prototype.createWin = function(niv) {
	Object.registerClass("wintable", WinTable);
	eval(this.listWinName).removeMovieClip();
	attachMovie("wintable",this.listWinName, niv);
	this.alistWin = eval(this.listWinName);
	this.alistWin.setPos(c.wtx, c.wty);
	this.alistWin.setScriptInst(this);
	this.alistWin.assignLabels();
	this.setStateOff();
	this.winIsCreate = true;
	_global._gHelpOnEnd = _global._gHlpOnEnd;
	_gHlpAddEvent(this.aListWin, _Level0);
};

ScriptTable.prototype.closeWin = function() {
	this.winIsCreate = false;
	field.closeWin();
	this.aUpdWin.closeWin();
	this.aListWin.closeWin();
	this.closeWinButtons();
};
////////////// Tables's buttons Window
ScriptTable.prototype.createWinButtons = function() {
	Object.registerClass("winButtons", winButtons);
	awinButtons.removeMovieClip();
	attachMovie("winButtons", "awinButtons", c.nivButtons);
	this.aButtonWin = awinButtons;
	this.aButtonWin.setPos(c.wbux, c.wbuy);
	this.aButtonWin.assignLabels();
	this.aButtonWin.assignFunctionsOnEvents(this);
	this.winButtonsIsCreate = true;
	_global._gHelpOnEnd = _global._gHlpOnEnd;
	_gHlpAddEvent(this.aButtonWin, _Level0);
};
ScriptTable.prototype.isWinButtonsCreate = function() {
	return this.winButtonsIsCreate;
};
ScriptTable.prototype.closeWinButtons = function() {
	this.winButtonsIsCreate = false;
	this.aButtonWin.closeWin();
	index.closeWin();
};

//// Table RollEvents : Display field list + index list  + table status 
ScriptTable.prototype.doRollEvent = function(rollTable) {
		// assign to ...,this.currentTable,this.basename
		this.assignMainObjectAndArray(undefined,rollTable,this.getCurrentChoice().Name);
		if (field == undefined) field = new ScriptField("awinfield", "awinfieldupd" , this);
		field.closeUpdWin();
		if (!field.isWinCreate()) field.createListWin(c.nivfield);
		field.showElements(this.currentTable);
		field.setStateOff();			
		if (index == undefined) index = new ScriptIndex("aindxlistwin", "aindxupdwin" , this);
		index.closeUpdWin();
		if (!index.isWinCreate()) index.createWin(c.nivIndexList, "indxlistwin", indxlistwin, c.wilx, c.wily);
		index.showElements(this.currentTable);
		index.setStateOff(this.currentTable);			
		this.displayStatus();
}	
ScriptTable.prototype.doReleaseEvent = function(currentTable) {		
		// assign to ...,this.currentTable,this.basename(first is a datas structure, second is just a name)
		this.assignMainObjectAndArray(undefined,currentTable,this.getCurrentChoice().Name);
		field.setCurrentChoice(this.currentTable);
		index.setCurrentChoice(this.currentTable);
		field.setElementChoice();		
		field.readElements();
		field.setStateOn();
		index.setElementChoice(0) ;
		index.setStateOn(this.currentTable);
		if (!this.isWinButtonsCreate()) this.createWinButtons();
		this.setMustReadDatas("datasUpd");
		this.displayStatus();
}	
ScriptTable.prototype.doOutEvent = function() {		
	   if ( (field.getCurrentChoice()!=undefined) && (field.getCurrentChoice()!="") ) {
		   // assign to ...,this.currentTable,this.basename(first is a datas structure, second is just a name)
		    this.assignMainObjectAndArray(undefined,field.getCurrentChoice(),this.getCurrentChoice().Name);
			this.aListWin.assignTitleLabel("off");
			field.showElements(this.currentTable);
			field.setStateOn();
			index.showElements(this.currentTable);
			index.setStateOn(this.currentTable) ;
			this.displayStatus();
		} else {
			this.aListWin.assignTitleLabel("on");
			field.closeWin();
			index.closeWin();
			// Close status win :
			this.closeUpdWin() ;
		}
		if (field.getElementChoice() != undefined && field.getElementChoice() != 0) {
			field.doRollEvent(field.getElementChoice());
			field.doOutEvent();
		}
		if (index.getElementChoice() != undefined && index.getElementChoice() != 0) {
			this.aListWin.onEnterFrame = function () {
				if (!this.hitTest( _root._xmouse, _root._ymouse, false)) {				
					index.doRollEvent(index.getElementChoice());
					index.doOutEvent();
					delete this.onEnterFrame ;
				}
				
			}
		
		}
}
ScriptTable.prototype.getTableStatus = function() {		
	var t = this.getCurrentChoice().tableStatus ; // all tables's status for THE base
	for (var i in t ) {
		for (var n in t[i]) {
			if(t[i][n].Name == this.currentTable.Name ) {
				return t[i][n] ;
			}
		}
	}	
}
ScriptTable.prototype.displayStatus = function() {	
	if (! this.isUpdWinCreate() ) this.createUpdateWin(c.nivStatus, "statusWin", StatusWin, c.wstx, c.wsty);
	this.aUpdWin.showContent(this.getTableStatus(),this.currentTable.Name);
}

//// Init before go to datas's update part
ScriptTable.prototype.initDatasUpdate = function() {
	this.invisibleDescripWindows();
	// If any change is made in description or if it's the first call :
	//   datasUpd is deleted or not exist (undefined)
	if (datasUpd == undefined) {
		// Create new script for data's update with params :
		//  windows instance names used in 'dataUpd' = "alistwin","aupdwin","asortwin"
		datasUpd = new ScriptDatasUpd("alistwin", "aupdwin", "asortwin", "aDataButtonsWin",this);
		this.setMustReadDatas("datasUpd");
	}
	// Go to data's update part with params :
	// 	Fields description's array = tfield
	//	Choosed table with its fields names's array  = field.getCurrentChoice()
	//  The baseName of the choosed table  = table.getCurrentChoice().name
	datasUpd.go(tfield, field.getCurrentChoice(), table.getCurrentChoice().name);
};



////////////////////////////////////////////////////////
ScriptTable.prototype.initSql = function() {
	this.invisibleDescripWindows("field");
	this.disableListWindows();
	if (importSql == undefined) {
		importSql = new ScriptSql("asqlwin", this.aButtonWin);
	}
	// normal button action become close button	
	this.aButtonWin.changeEventToReturn(importSql);
	//
	// Go to import and user sql resquest :
	// 	Fields description's array = tfield
	//	Choosed table with its fields names's array  = field.getCurrentChoice()
	//  The baseName of the choosed table  = table.getCurrentChoice().name
	importSql.go(tfield, field.getCurrentChoice(), table.getCurrentChoice().name);
};
ScriptTable.prototype.showElements = function(objBase) {
	// Objbase is the choosed base object
	awintable.showElements(objbase);
	awintable.assignScrolling(awintable.ohead, awintable.olist.otables);
};
ScriptTable.prototype.setCurrentChoice = function(currentBase) {
	this.currentBaseName = currentBase.name;
};
ScriptTable.prototype.getCurrentChoice = function() {
	for (i in tbase) {
		if (tbase[i].name == this.currentBasename) {			
			return tbase[i];
		}
	}
};
ScriptTable.prototype.setStateOn = function(tb) {
	if (tb.table.length<2) var empty = true ; else var empty = false ;
	awintable.assignTitleLabel("on",empty);
	awintable.putCreateButtonState("on",empty);
	awintable.putDeleteButtonState("on", this);
	this.labelsDeleteConfirm = labels.tableDeleteConfirm;
	this.labelsCreateName = labels.TableCreateName;
	this.labelsCreateTitle = labels.tableCreateTitle+" "+this.getCurrentChoice().name+".";
	this.AlertCreate = labels.tableAlertCreate;
	this.classType = "table";
	awintable.assignFunctionsOnEvents(this);
};

ScriptTable.prototype.setStateOff = function(tb) {
	if (tb.table.length<2) var empty = true ; else var empty = false ;
	awintable.assignTitleLabel("off",empty);
	awintable.putCreateButtonState("off");
	awintable.putDeleteButtonState("off", this);
};

ScriptTable.prototype.onEndcreateNewElement = function(newTable, fieldname, comment , format , typeIndx) {
	var o = new Object();
	o.name = newTable;
	o.field = new Array();
	var oo = new Object();
	oo.name = fieldname;
	o.field[1] = oo;
	var arr = this.getCurrentChoice().table ;
	if (arr.length == 0) {
		arr[0] = {} ;
		arr[1] = o;
		var objTable = arr[arr.length-1] ;
	} else {
		arr.push(o);
		var objTable = arr[arr.length-1] ;
		arr.sortOn("name");
	}	
	
	this.showElements(this.getCurrentChoice());	
	
	// create status
	var st = new Object() ;
	st.Comment = comment ;
	st.Type = format ;
	st.Row_format = "" ;
	if (st.Type == "") {
		st.Type = "MyISAM" ;
		st.Row_format = "Dynamic" ;
	}
	st.Name = newTable ;
	st.Index_length = 1024 ;
	var d = new Date(); 
	st.Create_Time = d.getFullYear()+"-"+(d.getMonth()+1)+"-"+d.getDate()+"  "+d.getHours()+"-"+d.getMinutes()+"-"+d.getSeconds() ;
	st.Update_Time = st.Create_Time ;
	st.Rows = 0 ;
	if (this.getCurrentChoice().tableStatus == undefined || this.getCurrentChoice().tableStatus[this.getCurrentChoice().name] == undefined ) {
		this.getCurrentChoice().tableStatus = new Object() ;	
		this.getCurrentChoice().tableStatus[this.getCurrentChoice().name] = new Array({}) ;
	}
	this.getCurrentChoice().tableStatus[this.getCurrentChoice().name].push(st);
	// Create index in object general data object 
	if (typeIndx.isSetAndNotNull()) {
		this.index_forCreation = new ScriptIndex(undefined, undefined, this) ;
		this.index_forCreation.assignMainObjectAndArray(undefined,objTable, undefined);
		if (typeIndx=="PRIMARY") var indxName = typeIndx ; else var indxName = fieldname ;
		var t = this.index_forCreation.onEndWinCreate(true, indxName, typeIndx) ;
		var of = new Object() ;
		of.name = fieldname ; of.seq = 1 ; of.subpart = "" ;		
		t.push(of);
		delete this.index_forCreation ;
	}
	
};

ScriptTable.prototype.returnFieldSqlCode = function(fldDesc) {
	var temp = fldDesc;
	var str = temp.name+" ";
	str += temp.typ;
	if (temp.def != "" || temp.noYesNull == "YES") {
		str += " DEFAULT ";
		if (temp.def != "") {
			str += " '"+temp.def+"' ";
		}
	}
	if (temp.def == "" || temp.noYesNull != "YES") {
		if (temp.noYesNull != "YES") {
			str += " NOT NULL";
		} else {
			str += " NULL";
		}
	}
	if (temp.autoincr == "auto_increment") {
		str += " AUTO_INCREMENT";
	}
	str += " "+temp.after;
	return str;
};
ScriptTable.prototype.returnIndexCode = function(fldDesc) {	
	var it = fldDesc.typeIndx ;
	if (it=="PRIMARY") it += " KEY" ;
	return it+" ( "+fldDesc.Name+" )" ;
}
// Method to create new table
ScriptTable.prototype.createNewElement = function() {
	this.onEndWinCreate = function(valid , newTable , comment , format ) {
		this.closeWinCreate();
		if (!valid) {
			this.restoreListWindows();
		} else {
			this.onEndCreateForTableCreation = function(valid) {
				if (!valid) {
					this.restoreListWindows();					
					field2.closeUpdWin();
					field.aUpdWin._visible = true ; // If any restore the normal upd Win of field.
				} else {
					var temp = field2.returnDatasFromInput();
					awinfieldupd.disableEventsAndGray();
					if (!field2.checkInput(temp)) {
						return;
					}
					scriptInstance = this;
					sendphp = new LoadVars();
					sendphp.language = param.language;
					sendphp.className = "table";
					sendphp.action = "create";
					sendphp.db = this.getCurrentChoice().name;
					sendphp.nameToCreate = newtable;
					sendphp.host = server.host;
					sendphp.login = server.login;
					sendphp.pass = server.pass;
					sendphp.req = "( "+this.returnFieldSqlCode(temp);
					if (temp.typeIndx.isSetAndNotNull() ) sendphp.req+=" , "+this.returnIndexCode(temp);
					sendphp.req += " ) " ;
					if ( comment.isSetAndNotNull() ) sendphp.req += "COMMENT = '"+comment+"' "; 
					if ( format.isSetAndNotNull() ) sendphp.req += " TYPE = "+format+" ";					
					sendphp.req +=";";
					receivephp = new LoadVars();
					receivephp.onLoad = function() {
						if (this.state != "ok") {
							scriptInstance.onEndAlert = function() {
								awinFieldUpd.restoreEvents();									
							};
							scriptInstance.showAlert(this.err, labels.allAlertTitle,scriptInstance);
							
						} else {
							scriptInstance.onEndAlert = function() {
								this.restoreListWindows();
								field2.closeUpdWin();
								field.aUpdWin._visible = true ; // If any, restore the normal upd Win of field.
								this.onEndcreateNewElement(newtable, temp.name, comment , format , temp.typeIndx);
								delete field2;
							};
							scriptInstance.showAlert(labels.tableCreateDeleteOk1+" '"+newtable+"' "+labels.tableCreateOk2, "",scriptInstance);
							
						}
					};
					sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
				}
				// End of : if (!valid) ... else
			};
			// End of : this.onEndCreateForTableCreation = function (valid) {
			field.aUpdWin._visible = false ; // If any the upd Win of a normal field don't have be shown
			field2 = new ScriptField("awinfieldin", "awinfieldupdin", this);
			field2.setUpdWinState("createForTableCreation", labels.fieldCreateForTableCreationTitle+" "+newTable, c.nivFieldUpd2);
		}
		// end of if (!valid) ... else
		
	};	
	// End of : this.onEndWinCreate = function (valid,newTable) {
	var underIsVisible = false;
	this.createWinCreate(c.nivCreate, labels.TableCreateName, labels.tableCreateTitle+" "+this.getCurrentChoice().name+".", labels.tableAlertCreate, underIsVisible,"", "winCreateTable");
		
};
// End of : ScriptTable.prototype.createNewElement
ScriptTable.prototype.onEndDeleteBase = function(deletedBase) {
	var temp = new Array(); temp[0] = {} ;
	var j = 0;
	for (var i = 1; i<tbase.length; i++) {
		if (tbase[i].name != deletedBase) {
			j++;
			temp[j] = tbase[i];
		}
	}
	tbase = new Array();
	tbase = temp;
	delete temp;
	awinbase.showElements();
	awinbase.assignScrolling(awinbase.ohead, awinbase.olist.obases);
	this.setCurrentChoice();
	// delete current database's choice for table script
	this.closeWin();
	field.setCurrentChoice();
	index.setcurrentchoice();
};
// deleteCurrent BASE
ScriptTable.prototype.deleteCurrentElement = function() {
	this.onEndWinDelete = function(valid) {
		if (!valid) {
			this.restoreListWindows();
			this.closeWinDelete();
		} else {
			scriptInstance = this;
			sendphp = new LoadVars();
			sendphp.language = param.language;
			sendphp.className = "base";
			sendphp.action = "delete";
			sendphp.nameToDelete = this.getCurrentChoice().name;
			sendphp.host = server.host;
			sendphp.login = server.login;
			sendphp.pass = server.pass;
			receivephp = new LoadVars();
			receivephp.onLoad = function() {
				if (this.state != "ok") {
					scriptInstance.onEndAlert = function() {						
						this.restoreListWindows();						
					};
					scriptInstance.showAlert(this.err, labels.allAlertTitle,scriptInstance);
				} else {
					scriptInstance.closeWinDelete();
					// Here : database's delete is Ok in php's prog.					
					scriptInstance.onEndAlert = function() {
						this.restoreListWindows();
						this.onEndDeleteBase(scriptInstance.getCurrentChoice().name);
					};
					scriptInstance.showAlert(labels.baseCreateDeleteOk1+" '"+scriptInstance.getCurrentChoice().name+"' "+labels.allDeleteOk2, "",scriptInstance);
				}
			};
			if (_version.demo) {
				#include "_version.demo02.as"
			} else {
				sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
			}
		}
		// end of if (!valid) ... else
	};
	var underIsVisible = false;
	this.createWinDelete(c.nivDelete, labels.tableDeleteConfirm, underIsVisible, this.getCurrentChoice().name);
};