﻿///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'toObject' add to Xml class.   (Alternative method of xml.readtables (more compact xml file)
///////////////////////////////////////////////////////////////////////////////////////////
//   tables mySql in Xml object ==> a structured Array
//   Xml structure : 
//		Only one markup with de basename : ex <MyBase>
//			One markup for each table ex : <custumer>, <item>
//				One markup named 'DATADESC'.
//              	 One markup for each column 's name (without content) : ex <name/> <adress/> <zipcode/> ...
//              One markup named 'DATAS'.
//					 A list of markup named 'C' with the content of all columns of all line 
//					  ex: <C>Content of the field(column) n° n of the record(line) n° m</C>
//
//		This method may be used with any type of arbo :
//			ex : <infos> -> <databasename> -> <contentname> -> content    instead of
//				 <base>  -> <tablename>    ->  <fieldname>  -> data
//////////////////////////////////////////////////////////////////////////////////////
// methods :
//				<Object> = object_xml.toObject() ;
//
//		        			Return an Object with the tables's fields et contents
//						    Object.table_name[line_number].column_name ;
//
//
// Example : 		
//				mySend = new loadVars() ;
//				myReceive = new Xml () ;
//				myReceive.onLoad = function () {
//						myText.text = this.toObject().customers[3].name ;
//		    			// Display the name of the third customer
//				}
//   			mySend.request = "SELECT * from customers" ; 					
//				mySend.sendAndload("php/readMySql.php",myReceive);
// 				// You have to create the "php/readMySql.php" program.									
/////////////////////////////////////////////////////////////////////////////
//
// 
XML.prototype.ignoreWhite = true;
XML.prototype.toObject = function() {
	// init array "twsap" used to replace coded strings (because xml invalides characters)
	var tswap = new Array();
	var o = new Object();
	o.src = "{";
	o.dest = "<";
	tswap.push(o);
	var o = new Object();
	o.src = "}";
	o.dest = ">";
	tswap.push(o);
	var o = new Object();
	o.src = "e";
	o.dest = "&";
	tswap.push(o);
	// create object with all tables
	var t = this.lastChild.childNodes;
	var returnedObject = new Object();
	for (var n in t) {
		// for each table in first xml node
		if (t[n].nodeName != undefined) {
			var nf = t[n].nodeName;
			returnedObject[t[n].nodeName] = new Array();
			var nline = 0;
			// Init sgbd line counter 
			var t2 = t[n].childNodes;
			// Recup content of one table
			for (var n2=0; n2<t2.length; n2++) {
				// for each node 
				if (t2[n2].nodeName == "DATADESC") {
					// columns names markup 
					var t3 = t2[n2].childNodes;
					// recup all columns 
					var tcolumn = new Array();
					// create object for all columns names
					var ncol = 0;
					// Init nb column  counter 
					for (var n3=0; n3<t3.length; n3++) {
						// for each columns name in xml							
						if (t3[n3].nodeName != undefined) {
							// loop garbage
							var str = new String(t3[n3].nodeName);
							str.str_replace(tswap, "~#");
							tcolumn[ncol] = str;
							ncol++;
						}
						// end : if (t3[n3].nodeName != undefined) { // loop garbage
					}
					// end : for (n3 in t3) {   // for each columns name in xml
					var maxcol = ncol-1;
				}
				// end : if (t2[n2].nodeName == "DATADESC") {	// columns names markup 
				if (t2[n2].nodeName == "DATAS") {
					// all datas container markup 
					var t3 = t2[n2].childNodes;
					// recup all datas of all line 
					var current_col = 0;
					// current column number 
					var oline = new Object();
					// Current line
					for (var n3=0; n3<t3.length; n3++) {
						// for each datas node
						if (t3[n3].nodeName != undefined) {
							// // loop garbage
							if (current_col>maxcol) {
								nline++;
								returnedObject[nf][nline] = oline;
								// add object for one line in tables Array
								current_col = 0;
								// current column number 
								oline = new Object();
								// Current line
							}
							var str = new String(t3[n3].firstChild.nodeValue);
							// One data
							oline[tcolumn[current_col]] = str.str_replace(tswap, "~#");
							// add datas in oject for line
							current_col++;
						}
						// end : if (t3[n3].nodeName != undefined) { // // loop garbage
					}
					// end : for (n3 in t3) {   // for each datas node
					nline++;
					returnedObject[nf][nline] = oline;						
					// add object for one line in tables Array
				}
				// end : if (t2[n2].nodeName == "DATAS) {	// all datas container markup
			}
			// end : for (n2 in t2) { 	// for each node 
		}
		// end : if (t[n].nodeName != undefined) {
	}
	// end : for (n in t) { // for each table in first xml node
	
	return returnedObject;
	// Return the object with all tableName[lines].columName
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode xml.toObject //////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'readbases' add to Xml class.   (read xml arbo which is a sgbdr structure
///////////////////////////////////////////////////////////////////////////////////////////
//   bases and tables mySql in Xml object ==> an arbo structured Array
//   Xml structure : 
//		Only one markup : <SERVER> ... </SERVER>
//			One markup for each base 
//				One markup for each table
//              	 One markup for each field
//				One markup : <_TABLE.STATUS> ... </_TABLE.STATUS> 
//					One markup for each base 
//						One <DATADESC> and <DATAS> markup for the bases's "table status" 
//							(see "toObject()" method for detail).
//				One markup : <_TABLE.INDEXS> ... </_TABLE.INDEXS> 
//					One markup for each table 
//						One <DATADESC> and <DATAS> markup for the table's indexs description
//							(see "toObject()" method for detail).
//              
//
//////////////////////////////////////////////////////////////////////////////////////
// methods :
//				<Object> = object_xml.readbases() ;
//
//		        			Return an Onject from a structured SGBDR (in XML format)
//						    Array[x].name 						<- "basename" 
//								    .table[y].name 				<- "tablename" 
//									         . field[z].name 	<- "fieldName"
//
//
// Example : 		
//				mySend = new loadVars() ;
//				myReceive = new Xml () ;
//				myReceive.onLoad = function () {
//						myText.text = this.readBases[3].table[5].field[12].name ;
//		    			// Display the name of the #12 field of the #5 table of the #3 base 
//				}
//   						
//				mySend.load("php/mySql.xml");
// 				// You have to create the file "php/mySql.xml" 									
/////////////////////////////////////////////////////////////////////////////
//
// 
XML.prototype.ignoreWhite = true;
XML.prototype.readBases = function() {
	// create object with all tables
	var t = this.lastChild.childNodes;
	//init main Array
	tFiles = new Array();
	var o = new Object();
	tfiles.push(o);
	for (n=0; n<t.length; n++) {
		// for each base in first xml node <SERVER>
		if (t[n].nodeName != undefined) {
			// loop garbage
			var o = new Object();
			o.name = t[n].nodeName;			
			o.table = new Array();
			var oo = new Object();
			o.table.push(oo);
			o.tableStatus = new Object() ;
			o.tableIndexs = new Object() ;
			tfiles.push(o);
			
			var t2 = t[n].childNodes;
			// Recup content of one base
			for (n2=0; n2<t2.length; n2++) {
			// for each table
				//     (loop garbage)
				if (t2[n2].nodeName != undefined) {
					if ( t2[n2].nodeName == "_TABLE.STATUS") {	
						var xXml = new XML( t2[n2].toString() ) ;
						tfiles[n+1].tableStatus = xXml.toObject();	
					} else if (t2[n2].nodeName == "_TABLE.INDEXS") {
						var xXml = new XML( t2[n2].toString() ) ;
						tfiles[n+1].tableIndexs = xXml.toObject();	
					} else {
						var o = new Object();
						o.name = t2[n2].nodeName;						
						o.field = new Array();
						var oo = new Object();
						o.field.push(oo);
						tfiles[n+1].table.push(o);
						var t3 = t2[n2].childNodes;
						// Recup content of one table
						for (n3=0; n3<t3.length; n3++) {
							// for each field
							if (t3[n3].nodeName != undefined) {
								// loop garbage
								var o = new Object();
								o.name = t3[n3].nodeName;
								tfiles[n+1].table[n2+1].field.push(o);
							}
							// end : if (t3[n3].nodeName != undefined) { // loop garbage
						}
						// end : for (n3=0;n3<t3.length;n3++) {   // for each field						
						delete tfiles[n+1].table[n2+1].field[0];
					} // End : if ( t2[n2].nodeName == "_TABLE.STATUS") {
				}
				// end : if (t2[n2].nodeName != undefined) { // loop garbage					
			}
			// end : for (n2=0 ;n2<t2.length;n2++ ) {	// for each table
			delete tfiles[n+1].table[0];			
		}
		// end : if (t[n].nodeName != undefined) { // loop garbage
	}
	// end : for (n=0;n<t.length;n++) { // for each base in first xml node <SERVER>
	delete o;
	delete tfiles[0];
	delete oo;
	
	return tfiles;
	
	// Return the onject with all tables[lines].colmums
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode xml.readbases //////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// Sounds Methods  add to class : MovieClip of Flash
///////////////////////////////////////////////////////////////////////////////////////////
//   
//   
///////////////////////////////////////////////////////////////////////////////////////////
// private
MovieClip.prototype.playCurrentSound = function (s) {	
	this.currentSound = new Sound() ;
	this.currentSound.parentMc = this ;
	this.currentSound.onLoad = function(ok){
		this.onSoundComplete = function() {
			this.parentMc.onEndSound() ;
			this.parentMc.removeMovieClip();			
			delete this ;			
		}	
		this.parentMc.onSoundLoaded(ok) ;
 		//if (ok) this.start() ;
		
	}
	
	this.currentSound.loadSound(s,true);
	
	this.onEnterFrame=function(){
		this.onEachFrame ( (this.currentSound.getBytesLoaded()/this.currentSound.getBytesTotal())*100);
		if(this.currentSound.getBytesLoaded()==this.currentSound.getBytesTotal() &&
		   this.currentSound.getBytesTotal()>1){
				delete this.onEnterFrame ;
		}
	}
	return this.currentSound ;
}
// public

MovieClip.prototype.playSound = function (s) {
	if (this.mcSoundLevel == undefined)	this.mcSoundLevel = new Number(0) ;
	this.mcSoundLevel++  ;
	this.createEmptyMovieClip("mcSound"+this.mcSoundLevel,this.mcSoundLevel) ;
	var mc= eval("this.mcSound"+this.mcSoundLevel) ;
	mc.parentMc = this ;
	mc.onEndSound = function () { this.parentMc.onEndSound()} ;
	mc.onEachFrame = function (scale_percent) { this.parentMc.onEachFrame(scale_percent)} ;
	mc.onSoundLoaded = function (exist) { this.parentMc.onSoundLoaded(exist)} ;
	return mc.playCurrentSound(s) ;
}
MovieClip.prototype.deleteSound = function (idSound) {
	idSound.stop() ;
	idSound.parentMc.removeMovieClip();	
}



///////////////////////////////////////////////////////////////////////////////////////////
// END Sounds Methods  add to class : MovieClip of Flash
///////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'loadjpg' rajouter à la classe : MovieClip de Flash
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.loadjpg = function(image) {
	this.createEmptyMovieClip("contenant", 1);
	
	this.contenant.loadMovie(image);
	this.onEnterFrame = function() {
		if (this.contenant.getBytesLoaded()>1 && this.contenant.getBytesLoaded()>=this.contenant.getBytesTotal()) {
			this.onComplete();
			delete this.onEnterFrame;
		}
	};
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode MovieClip.loadjpg /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////
// Methods 'setPos' and 'setPosCenter' add to Flash class : MovieClip 
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.setPos = function(x, y) {
	this._x = x;
	this._y = y;
};
MovieClip.prototype.setPosCenter = function() {
	var posx = (Stage.width-this._width)/2;
	var posy = Stage.height/2-(this._height/2);
	this.setPos(posx, posy);
};
///////////////////////////////////////////////////////////////////////////////////////////
// END Methods 'setPos' and 'setPosCenter' 
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'loadMc' add to Fllash class : MovieClip 
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.loadMc = function(mc,isGaugeNeeded,streamingPercent) {
	var niv = this.getNextFreeDepth() ;
	this.createEmptyMovieClip("Mc", niv );
	this.Mc.mc = mc ;
	this.Mc.onGaugeIsStarted = function () {
		this.loadMovie(this.mc);
	}	
	if (isGaugeNeeded)	_gGauge (this.Mc,"MovieClip",3);
	else this.Mc.onGaugeIsStarted() ;	
	this.countF=0;
	this.streamingPercent = streamingPercent ;
	delete this.stopped ;
	this.onEnterFrame = function() {
		this.countF++ ;
		if (this.Mc.getBytesLoaded() > 0 && this.Stopped<>true ) {
			this.Mc._visible = false ;
			if (this.streamingPercent * 100 > 0 ) {
				this.Mc.stop();
				this.stopped = true ;
			}
		}
		if (this.Mc.getBytesLoaded()>1 && this.Mc.getBytesLoaded()>=this.Mc.getBytesTotal()) {			
			this.onComplete(true);
			this.Mc._visible = true ;
			delete this.countF ;
			delete this.onEnterFrame;
		}
		if (this.Mc.getBytesLoaded()>0 && 
			this.Mc.getBytesLoaded()>=(this.Mc.getBytesTotal()*streamingPercent) &&
			this.streamingPercent * 100 > 0 ) {	
					this.mc.gotoAndStop(1); 
					this.Mc.onEnterFrame = function () {
						if (this._width > 0) {
							this.play();
							this._visible = true ;
							this._parent.onBeginStreaming(true) ;
							delete this.onEnterFrame ;
						}
					}
					this.streamingPercent = undefined ;
					
		}
		if (this.countF>3 &&  this.Mc.getBytesTotal() == -1) {			
			this.onComplete(false);
			delete this.Mc ;
			delete this.countF ;
			delete this.onEnterFrame;
		}
	};
	
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode MovieClip.loadjpg /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////
// 'getNextFreeDepth' method add to MovieClip class prototype ///////////////////////////
//                    return 
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.getNextFreeDepth = function() {
	var niv = 0 ;
	for (var i in this) {
		if ( typeof(this[i]) == "movieclip" ) {
			if (this[i].getDepth() >= niv) 
			    niv = this[i].getDepth()+1;
		}
	}
	return niv ;
}
//////////////
	

///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'beButton' rajouter à la classe : MovieClip de Flash ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.beButton = function(over, out, down) {	
	this.isButton = true;
	if ( over.isSetAndNotNull() ) {
		this.onRollOver = function() {
			this.gotoAndStop(over);
		};
		this.onRollOut = function() {
			this.gotoAndStop(out);
		};
		this.onPress = function() {
			this.gotoAndStop(down);
		};
	} else {
		delete this.onRollOver ;
		delete this.onPress ;
		delete this.onRollOut ;
	}
	
		
	
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la Méthode MovieClip.loadjpg /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthodes 'invisible' et 'visible' rajouter à la classe : MovieClip de Flash
//     ces methodes permettent de rendre invisible puis restaurer
//     tous les objets d'un clip sauf ceux d'un tableau passé en parametre
//     les objets qui ne sont pas nommés ne sont pas traités.
///////////////////////////////////////////////////////////////////////////////////////////
// rend les objets d'un clip invisibles
// sauf ceux d'un tableau d'objets envoyé en parametre
MovieClip.prototype.invisible = function(t_obj) {
	var i = 0;
	this.tbh = new Array();
	for (var n in this) {
		if (this[n]._visible != undefined && this[n] instanceof MovieClip && this[n]._name.substring(0, 8) != "instance") {
			var ok = true;
			for (var j in t_obj) {
				if (t_obj[j]._name == this[n]._name) {
					ok = false;
					break;
				}
			}
			if (ok) {
				var to = new Object();
				to.obj = this[n];
				to.etat = this[n]._visible;
				this.tbh[i] = to;
				i++;
			}
		}
	}
	for (var i in this.tbh) {
		this.tbh[i].obj._visible = false;
	}
};
MovieClip.prototype.visible = function() {
	for (var i in this.tbh) {
		this.tbh[i].obj._visible = this.tbh[i].etat;
	}
	delete this.tbh;
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN des methodes 'invisible' et 'visible' ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'inverse', added to Flash class : MovieClip
//     return a reverse Array even if it's an Object's Array
//     The reverse() Flash's method didn't work with this kind of array !!!
//     The returned Array begin at the position : 1
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.inverse = function(tin) {
	var tout = new Array();
	var j = 0;
	for (var i in tin) {
		j++;
		tout[j] = tin[i];
	}
	return tout;
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// End of inverse() method    //////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'inverseObject', added to Flash class : MovieClip
//     return the reversed Object
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.inverseObject = function(obj) {
	var o = new Object();
	for (var i in obj) { o[i]=obj[i] } ;	
	return o ;
};	
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// End of inverseObject() method    //////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthodes 'disableOne' et 'enableOne' rajouter à la classe : MovieClip de Flash
//     ces methodes permettent de de-activer puis de restaurer LE movieClip 
///////////////////////////////////////////////////////////////////////////////////////////
// Les MCs sont grisés
MovieClip.prototype.disableOne = function(alpha,force) {
	if (alpha<1 || alpha == undefined) {
		var alpha = 25 ;
	}
	if (this.objOne != undefined && not force) {
		return;
	}
	this.objOne = new Object();
	this.objOne.alpha = this._alpha;
	this._alpha = Math.max(alpha, this._alpha-alpha);
	this.objOne.tfunc = new Array();
	for (var i in this) {
		if (this[i] instanceof Function) {
			var oo = new Object();
			oo.event = i;
			oo.f = this[i];
			this.objOne.tfunc.push(oo);
			delete this[i];
			delete oo;
		}
	}
	// END : for ( var i in this )	
};
// MovieClip.prototype.disableOne = function (alpha) {
// Restaure les fonctions 
MovieClip.prototype.enableOne = function() {
	//for (var i in this.objOne.tfunc) {
	for (var j in this.objOne.tfunc) {
		this[this.objOne.tfunc[j].event] = this.objOne.tfunc[j].f;
	}
	this._alpha = this.objOne.alpha;
	//}
	delete this.objOne;
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN des methodes 'disableOne' et 'enableOne' ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'isItEnable' rajouter à la classe : MovieClip de Flash
//     return false if the mc is disable by this.disableOne()
///////////////////////////////////////////////////////////////////////////////////////////
MovieClip.prototype.isItEnable = function() {
	if (this.objOne != undefined) {
		return false;
	} else {
		return true;
	}
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN de la methode 'isItEnable'      /////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthodes 'disable' et 'enable' rajouter à la classe : MovieClip de Flash
//     ces methodes permettent de de-activer puis de restaurer toutes les 
//     methodes assignées aux movieClips (boutons generalemnt) contenus dans
//     le movieClip 
//     les objets qui ne sont pas nommés ne sont pas traités.
///////////////////////////////////////////////////////////////////////////////////////////
// sauve et delete les fonctions des MCs d'un Clip
// sauf ceux d'un tableau d'objets envoyé en parametre
// Les MCs sont grisés
MovieClip.prototype.disable = function(t_obj, alpha, bool) {
	
	if (alpha<1 || alpha == undefined) {
		var alpha = 25;
	}
	if (this.tb != undefined) {
		return;
	}
	this.tb = new Array();
	for (var i in this) {
		if (this[i] instanceof MovieClip && this[i]._name.substring(0, 8) != "instance"  ) { // && this[i]._name.substring(0, 5) != "ohlp_"
			var ok = true;
			for (var j in t_obj) {
				if (t_obj[j]._name == this[i]._name) {
					ok = false;
					break;
				}
			}
			
			if (ok) {
				var o = new Object();
				o.mc = this[i];
				o.alpha = this[i]._alpha;
				o.cascade = bool;
				this[i]._alpha = Math.max(alpha, this[i]._alpha-alpha);
				o.tfunc = new Array();
				for (var j in this[i]) {
					if (this[i][j] instanceof Function) {
						var oo = new Object();
						oo.event = j;
						oo.f = this[i][j];
						o.tfunc.push(oo);
						delete this[i][j];
						delete oo;
					}
				}
				this.tb.push(o);
				delete o;
				if (bool) {
					this[i].disable([], alpha, bool);
				}
			}
			// if (ok)
		}
		// if (this[i] instanceof
	}
	// for(var i in this) {		
};
// MovieClip.prototype.disable = function (t_obj) {
// Restaure les fonctions 
MovieClip.prototype.enable = function() {
	for (var i in this.tb) {
		for (var j in this.tb[i].tfunc) {
			this.tb[i].mc[this.tb[i].tfunc[j].event] = this.tb[i].tfunc[j].f;
		}
		this.tb[i].mc._alpha = this.tb[i].alpha;
		if (this.tb[i].cascade) {
			this.tb[i].mc.enable();
		}
	}
	delete this.tb;
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN des methodes 'disable' et 'enable' ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthodes 'beGrayed' et 'undoGrayed' rajouter à la classe : MovieClip de Flash
//     ces methodes permettent de griser puis de restaurer toutes les 
//      movieClips (boutons generalemnt) contenus dans
//     le movieClip 
//     les objets qui ne sont pas nommés ne sont pas traités.
///////////////////////////////////////////////////////////////////////////////////////////
// Grise les MCs d'un Clip
// sauf ceux d'un tableau d'objets envoyé en parametre
MovieClip.prototype.beGrayed = function(t_obj, alpha) {
	var alpha = 20;
	if (this.tbg != undefined) {
		return;
	}
	this.tbg = new Array();
	for (var i in this) {
		if (this[i] instanceof MovieClip && this[i]._name.substring(0, 8) != "instance") {
			var ok = true;
			for (var j in t_obj) {
				if (t_obj[j]._name == this[i]._name) {
					ok = false;
					break;
				}
			}
			if (ok) {
				var o = new Object();
				o.alpha = this[i]._alpha;
				o.mc = this[i];
				this[i]._alpha = Math.max(alpha, this[i]._alpha-alpha);
				this.tbg.push(o);
				delete o;
			}
			// if (ok)
		}
		// if (this[i] instanceof
	}
	// for(var i in this) {		
	//onEndGrayed(t_obj);
	this.onEndGrayed();
};
// MovieClip.prototype.disable = function (t_obj) {
// Restaure l'alpha des MCs 
MovieClip.prototype.undoGrayed = function() {
	for (var i in this.tbg) {
		this.tbg[i].mc._alpha = this.tbg[i].alpha;
	}
	delete this.tbg;
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN des methodes 'beGrayed' et 'undoGrayed' ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// 'doFlashEffect' method add to the Flash MovieClip's Class 
//     Visual light effect 
//
///////////////////////////////////////////////////////////////////////////////////////////

MovieClip.prototype.doFlashEffect = function(l,a,la,enda,unconditional) {
	
	this.myColor = new Color(this);
	this.colorObj = new Object();
	// Constants
	if (l==undefined) var l = 0         //light begin
	if (a==undefined) var a = 3;		// acceleration
	var s = 10;							// speed
	var max = 255;						// light max
	
	if (la==undefined) var la = -255;
	var aa = a;	
	var sa = s;	
	var maxa = 0 ;
	if (enda==undefined) var enda = 100 ;	// alpha's % for the end of effect
	
	if (this._parent.Dfe == undefined) this._parent.Dfe = new Array();
	
	// Test if already do it
	for (var i in this._parent.Dfe) {
		if (this._parent.Dfe[i] == this._name) {
			var already = true ;		
		}
	}	
	if (!already) this._parent.Dfe.push(this._name) ;		
	
	if (!this._parent.niv.isSetAndNotNull) this._parent.niv = new Number(0); 
	
	this._parent.niv ++;var i = this._parent.niv ;
	this.createEmptyMovieClip(this._name+i,i);
	var mc = eval("this."+this._name+(i));
	mc.onEnterFrame = function() {
		if (already and (!unconditional) ) {
			this._parent._visible = true ;
			this._parent.onEndFlashEffect();
			this.removeMovieClip();
		}
		l = l+s;
		la = la+sa;
		s *= a;
		sa *= aa;
		this._parent.colorObj = { rb:l, bb:l, gb:l ,ab:la};
		this._parent.myColor.setTransform(this._parent.colorObj);
		this._parent._visible = true ;

		if (l>=max ) {
			this._parent.colorObj = {rb:max, bb:max, gb:max,ab:maxa, aa:enda};
			this._parent.myColor.setTransform(this._parent.colorObj);
			delete this.onEnterFrame;
			// Constants 2nd round
			var a = .7; // deceleration
			var s = 50; // speed
			var end = 1; // colors end (near 0)	
			
			var l = max; 
			this.onEnterFrame = function() {
				l = (l-end)*a;
				this._parent.colorObj = {rb:l, bb:l, gb:l};
				this._parent.myColor.setTransform(this._parent.colorObj);
				if (l<=end ) {
					this._parent.colorObj = {rb:0, bb:0, gb:0 , aa:enda};
					this._parent.myColor.setTransform(this._parent.colorObj);
					this._parent.onEndFlashEffect();
					this.removeMovieClip();
				}
			};
		}
	};
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END doFlashEffect method /////////////// ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// 'fadeInOut' method add to the Flash MovieClip's Class 
//     Do a 'fade in or out' effect to a movieClip 
//
///////////////////////////////////////////////////////////////////////////////////////////

MovieClip.prototype.fadeInOut = function(step,end) {
	var i = this.getNextFreeDepth() ;
	this.createEmptyMovieClip(this._name+i,i);
	var mc = eval("this."+this._name+(i));
	mc.onEnterFrame = function() {		
		this._parent._alpha +=step;
		if ( 	(step>=0 && this._parent._alpha >=end ) ||
			 	(step<0  && this._parent._alpha <=end )      ) {
						this._parent.onEndFadeInOut();
						delete this.enterFrame ;
						this.removeMovieClip() ;
		}
	}
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END FadeInOut method /////////////// ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// moveToLocation() and doRotate() methods add to MovieClip Class
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////
// Public main methods 
////////////////////////
MovieClip.prototype.moveToLocation = function (angle,distance,dx,dy,tracing,scale,coefSpeed,alphaStep,delayBetweenMove) {	
	this.delayBetweenMove = delayBetweenMove;
	this.alphamoins = alphaStep ;
	this.coefSpeed = coefSpeed ;
	this.scale = scale ;
	this.tracing = tracing ;
	this.distance = distance ;
	this.angle = angle ;
	this.ox = this._x ;
	this.oy = this._y ;
	this.dx = dx ;
	this.dy = dy ;
	
	if (distance == 0 || angle == 0) {
		// si distance == 0 alors dx et dy doivent etre assignés
		var lx = this.dx-this.ox ;
		var ly = this.dy-this.oy ;
		this.distance = Math.round(Math.sqrt(lx*lx+ly*ly)) ;
		this.angle = MyMath.radianToDegree(Math.atan2(ly,lx));
	}
	this.lx=Math.cos(MyMath.degreeToRadian (this.angle)) * this.distance ;
	this.ly=Math.sin(MyMath.degreeToRadian (this.angle)) * this.distance ;
	this.dx=this.ox+this.lx ;
	this.dy=this.oy+this.ly ;
	
	this.pos = this.distance ;
	//this.movingNiv = 0 ;
	this.onEnterFrame = this.moving ; 	
}

MovieClip.prototype.doRotation = function (angle,speed,tracing,am) {	
	this.speed = speed ;
	this.angle = angle ;
	this.tracing = tracing ;
	this.alphaMoins = am ;
	var rd = this._rotation ;	
	if (rd < 0  ) rd = 360-rd ;
	var re = rd+this.angle ;
	if (re >= 360  ) re -=360 ;
	if (re < 0  ) re +=360 ;
	this.rotationEnd = re ;
	this.currentRotation = rd ;
	this.action = "rotate" ;
	this.onEnterFrame = this.moving ; 		
}
//////////////////////////////
// Private 'moving()' method 
//////////////////////////////

MovieClip.prototype.moving = function() {
	var coefSpeed = this.coefSpeed ; // .25;//
	var alphaMoins = this.alphaMoins ; //70 ; // 20 ;
	if (this.tracing) {		
		var i = this._parent.getNextFreeDepth(); 
		this.duplicateMovieClip(this._name+i,i);
		var mc = eval("this._parent."+this._name+(i));
		mc._alpha -= alphamoins ;		
		mc.onEnterFrame = function () {
			this._alpha -= alphamoins ;
			if (this._alpha <= 0) {
				this.removeMovieClip();
			}
		}
	}
	if (this.action == "rotate") {
		this.currentRotation += this.speed ;			
		if (this.currentRotation >= this.rotationEnd)  {
			this.currentRotation = this.rotationEnd ;				
			this._rotation = this.currentRotation  ;
			if (this.currentRotation > 180) this._rotation = (this.currentRotation - 360 ) ;
			delete this.onEnterFrame ;
			this.onEndRotate();
		}
		
		this._rotation = this.currentRotation  ;
		if (this.currentRotation > 180) this._rotation = (this.currentRotation - 360 ) ; 
	} else {
		if (this.delayBetweenMove == 0) this.onFlagMove() ;
		this.delayBetweenMove -- ;		
		var speed = this.pos * coefSpeed ;
		if (this.scale != 0) {
			var coefScale = (1 + (this.scale/100) * speed / this.distance );
			this._height = this._height*coefScale ;
			this._width  = this._width*coefScale ;
		}
		var x = Math.cos(MyMath.degreeToRadian (this.angle)) * speed ;
		var y = Math.sin(MyMath.degreeToRadian (this.angle)) * speed ;	
		this._x+=x;
		this._y+=y;
		this.pos -= speed ;		
		if (this.pos<=2) {
			delete this.onEnterFrame ;
			if (this.delayBetweenMove >= 0 ) this.onFlagMove();
			this.onEndMove();		
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////
// END OF moveToLocation() method 
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'getDateFr' rajouter à la classe : Date de Flash
//     Renvoi la date formater jj/mm/aa
//     
///////////////////////////////////////////////////////////////////////////////////////////
Date.prototype.getDateFr = function() {
	jj = (100+this.getDate()).toString().substring(1, 3);
	mm = (100+this.getMonth()+1).toString().substring(1, 3);
	aa = (this.getFullYear()).toString().substring(2, 4);
	return jj+"/"+mm+"/"+aa;
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// FIN des methode getDateFr /////////////// ///////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'isSetAndNotNull' add to String class
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.isSetAndNotNull = function() {	
	var x = this;
	if (x instanceof Number) {
		x = x.toString();
		if (x == "0") {
			return undefined;
		}
		if (x == "NaN") {
			return undefined;
		}
	} else if (x instanceof String) {
		if (x.length == undefined) {
			return undefined;
		}
		if (x.length<1) {
			return undefined;
		}
	} else {		
		var j = 0;
		for (var i in x) {
			j++;
		}		
		if (j<2 && !(x.valueOf().length)) {
			return undefined;
		}
	}
	// Instance of Object only in the future !!!
	return true;
};
Number.prototype.isSetAndNotNull = String.prototype.isSetAndNotNull ;
Array.prototype.isSetAndNotNull = String.prototype.isSetAndNotNull ;
ASSetPropFlags(Array.prototype, "isSetAndNotNull",1);
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END : Méthod 'isSetAndNotNull' add to String and Number class //////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'str_replace' add to the class : String of Flash
///////////////////////////////////////////////////////////////////////////////////////////
// 
// What do it :
// 	Change all occurence of <sources> by <destinations> in the string 
// 	and delete a 'locate mark' if exist
//
// Entry : 		
//			mark 			= 	String to locate the beginning of changing  
//									or = "" if all 'this' must be scanned.
//			strObjArray		= 	an Array of objects with 
//										object.src  = str to be replaced
//										object.dest = str which replace
// Out ;
//			return the changed string without change the original String
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.str_replace = function(strObjArray, mark) {
	var t = strObjArray;
	var preced = 0;
	var psb = 0;
	var out = new String();
	///////////////////////////////////////////////////////////////////////////////
	if (mark != "" && mark != undefined) {
		while (preced<this.length) {
			var pm = this.indexOf(mark, preced);
			if (pm != -1) {
				// match the mark
				out += this.substring(preced, pm);
				var pme = pm+mark.length;
				var match = false;
				for (var i in t) {
					var pse = pme+t[i].src.length;
					if (t[i].src == this.substring(pme, pse)) {
						// match a string to replace
						out += t[i].dest;
						match = true;
						preced = pse;
						break;
					}
					//if												   
				}
				//for
				if (!match) {
					//out += this.substring(pme,this.length);
					preced = pme;
				}
			} else {
				out += this.substring(preced, this.length);
				break;
			}
		}
		//while
		////////////////////////////////////////////////////////////////////////////////
	} else {
		while (psb<this.length) {
			var match = false;
			for (var i in t) {
				var pse = psb+t[i].src.length;
				if (t[i].src == this.substring(psb, pse)) {
					// match a string to replace
					out += this.substring(preced, psb)+t[i].dest;
					match = true;
					psb = pse;
					preced = pse;
					//trace(out+"/"+pme+"/"+preced+"/"+this.substring(preced)+"/"+pse);
					break;
				}
				//if
			}
			// for				
			if (!match) {
				psb++;
			}
			//if			
		}
		//end while			
		out += this.substring(preced, this.length);
		break;
	}
	// end if mark != ""
	/////////////////////////////////////////////////////////////////////////////////
	return out;
};
// end function
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END of method str_replace ///////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthode 'convertXml' add to class : String of Flash
///////////////////////////////////////////////////////////////////////////////////////////
//   Change some character to 'special substring' in a string (this)
//	 which will be a part of Xml file
//   		Example : '>' '<' and &
//   and return a string result without change the source string (this)
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.convertXml = function() {
	var tt = new Array();
	var o = new Object();
	o.src = "<";
	o.dest = "~#{";
	tt.push(o);
	var o = new Object();
	o.src = ">";
	o.dest = "~#}";
	tt.push(o);
	var o = new Object();
	o.src = "&";
	o.dest = "~#e";
	tt.push(o);
	return this.str_replace(tt, "");
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END of method convertXml ////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////
// Méthod 'convert_apostr' add to class : String of Flash
///////////////////////////////////////////////////////////////////////////////////////////
//   Change "'" character to char in a string (this)
//   and return a string result without change the source string (this)
///////////////////////////////////////////////////////////////////////////////////////////
String.prototype.convert_apostr = function(char) {
	var o = new Object();
	o.src = "'";
	o.dest = char;
	tt= [o] ;
	return this.str_replace(tt, "");
};
///////////////////////////////////////////////////////////////////////////////////////////
///////////////////// END of method convertXml ////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
// Static class MyMath
///////////////////////////////////////////////////////////////////////////////////////////

function MyMath () {
}
MyMath.radianToDegree = function(r) {
	return  (r/Math.PI) * 180 ;
}
MyMath.degreeToRadian = function(d) {
	return  (d/180) * Math.PI ;
}



///////////////////////////////////////////////////////////////////////////////////////////
// Méthods  add to _Global 
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
//    _gNewEmpty() : Return an new empty Clip from  target
///////////////////////////////////////////////////////////////////////////////////////////
_global._gNewEmptyClip = function(target) {
	if (target == undefined) target = _Level0 ;
	var niv = target.getNextFreeDepth() ;
	target.createEmptyMovieClip("empty"+niv,niv);
	return eval("target.empty"+niv);
}
///////////////////////////////////////////////////////////////////////////////////////////
//   END OF  _gNewEmpty() : Return an new empty Clip from  target
///////////////////////////////////////////////////////////////////////////////////////////	


///////////////////////////////////////////////////////////////////////////////////////////
//    _gAlert() : Display during developpement   ( trace() 's like )
///////////////////////////////////////////////////////////////////////////////////////////
_global._gAlert = function(msg,x,y,w,h) {
	if (_root.eTx_alert==undefined) {
		if (x == undefined) x = 550 ;
		if (y == undefined) y = 200 ;
		if (w == undefined) w = 400 ;
		if (h == undefined) h = 350 ;
		_root.createEmptyMovieClip("eTx_alert",99);
		_root.eTx_alert.createEmptyMovieClip("eHead",2);
		_root.eTx_alert.eHead.createTextField("txt",1,x,y-16,w,20) ;
		_root.eTx_alert.eHead.txt.background = true ;
		_root.eTx_alert.eHead.txt.backgroundColor = 0xFF3300;
		_root.eTx_alert.eHead.txt.textColor = 0xffffff;
		_root.eTx_alert.fmt = new TextFormat("arial",12,0xffffff,true);
		_root.eTx_alert.fmt.bold = true;
		_root.eTx_alert.eHead.txt.text = "Debug alert window";
		_root.eTx_alert.eHead.txt.setTextFormat(_root.eTx_alert.fmt);
		
		//		
		_root.eTx_alert.createEmptyMovieClip("eClose",3);
		_root.eTx_alert.eClose.createTextField("txt",1,x+w-16,y-10,12,6) ;
		_root.eTx_alert.eClose.txt.background = true ;
		_root.eTx_alert.eClose.txt.backgroundColor = 0x00ff00;
		_root.eTx_alert.eClose.onRelease = function () {
			this._parent.removeMovieClip();
		}
		//
		_root.eTx_alert.eHead.onPress = function () {
			this._parent.startDrag();
		}
		_root.eTx_alert.eHead.onRelease = function () {
			this._parent.stopDrag();
		}
		_root.eTx_alert.createTextField("txt",1, x,y, w,h) ;
		_root.eTx_alert.txt.type = "input";
		_root.eTx_alert.txt.selectable = true;
		_root.eTx_alert.txt.background = true;
		_root.eTx_alert.txt.backgroundColor = 0xbbbbbb;
		_root.eTx_alert.txt.textColor = 0xff0000 ;
	}
	_root.eTx_alert.txt.text +="\n"+ msg ;
	
}

///////////////////////////////////////////////////////////////////////////////////////////
//    _gGetParam() 			: Get _global.param
//    _gSetParam() 			: Set param in _global 
///////////////////////////////////////////////////////////////////////////////////////////
_global._gSetParam = function(p) {	
	_global._gParam = p ;
}
_global._gGetParam  = function() {
	return _gParam ;
}

///////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////
//    Globals Sounds Methods  
///////////////////////////////////////////////////////////////////////////////////////////

_global._gPlaySound = function (s,isGaugeNeeded) {
	this.currentSound.stop();
	delete this.currentSound ;
	this.currentSound = new Sound() ;
	this.currentSound.onLoad = function(ok){
		this.onSoundComplete = function() {
			delete this ;
		}
		
 		if (ok) this.start() ;
	}
	this.currentSound.s = s ;	
	this.currentSound.onGaugeIsStarted = function () {
		this.loadSound(this.s,true);
	}
	var tx=labels.ggeSound ;
	if (!tx.isSetAndNotNull()) tx = "Sounds" ;
	
	if (isGaugeNeeded)	_gGauge (this.currentSound,tx,2);
	else this.currentSound.onGaugeIsStarted() ;
	
}
_global._gDeleteSound = function () {
	this.currentSound.stop();
	delete this.currentSound ;
}

///////////////////////////////////////////////////////////////////////////////////////////
//         TAB management :
///////////////////////////////////////////////////////////////////////////////////////////
//              tabControlAdd() is used to build _Global.tab with parameters from
//                               the different possible config.
//              tabControl()     is used to call one tabIndex order's config.
///////////////////////////////////////////////////////////////////////////////////////////

// Set the init config for anim tab management
_global._gTabControlAdd = function (action,cfgId,fldName,indx) {	
		// Add one element in a config .
		// action may be "fld" : Add in List of fields for tabIndex 
		//						 with its indx's position
		//				 "norec" : List of fields without rect. display
		//               "focus"  : The first field to have focus for this 
		//						     config (just one element)
		if (this.tab == undefined) this.tab = new Object();		
		var o = new Object();
		o.fldName = fldName ;
		o.indx    = indx ;
		if (this.tab[cfgId]== undefined) this.tab[cfgId] = new Object() ;
		if (this.tab[cfgId][action] == undefined) this.tab[cfgId][action] = new Array() ;
		this.tab[cfgId][action].push(o) ;		
}
_global._gTabControl = function (cfgId,path) {
		if (cfgId.toUpperCase() == "noTab".toUpperCase() ) {
			path.createTextField("eTx_noTab",1, -10, -10, 5, 5) ;
			path.eTx_noTab.tabIndex=1 ;
		} else {
			for (i in this.tab) {
				if (i == cfgId) {
					// Set order
					for (j in this.tab[i].fld ) {
						eval(path+"."+this.tab[i].fld[j].fldName).tabIndex = this.tab[i].fld[j].indx ;
					}
					// Set noRect fields
					for (j in this.tab[i].norec ) {
						eval(path+"."+this.tab[i].norec[j].fldName)._focusrect = false ; 
					}
					// Set first focus.
					for (j in this.tab[i].focus) {
						Selection.setFocus ( eval(path+"."+this.tab[i].focus[j].fldName) ) ; 
					}
				}
			}
		}
		
}


///////////////////////////////////////////////////////////////////////////////////////////
//        FMA Helpy settings :
///////////////////////////////////////////////////////////////////////////////////////////
//              hlpSet() is used to build _Global.help with parameters 
//						  of all the assistants.	
///////////////////////////////////////////////////////////////////////////////////////////
// onEnd func (will be assigned to _gHelpOnEnd func)
_global._gHlpOnEnd = function (current) {	
	_gGetParam().helpy = _gHelpGetHelpy() ;
	_gGetParam().voice = _gHelpGetVoice() ;		
	if ( ! _gHelpGetHelpy() ) _gHlpRemoveEvent() ;
	else {
		if ( !current.helpy ) _gHlpRemoveEvent(current.id) ;	}
	
	if ( 
		 (_gHelpGetParent()._name == "aCfgWin") ) 
		_gHelpGetParent().ohelpy.ocompo.setValue(_gHelpGetHelpy() ) ;
		_gHelpGetParent().oVoice.ocompo.setValue(_gHelpGetVoice() ) ;
}

_global._gHlpRemoveEvent= function (hName) {
	_global._gHlpDisable = function (hMc) {
		delete hMc.onRollOver ;
		delete hMc.onPress ;
		hMc._visible= false ;	
		// ici 050515
		eval("hMc._parent.oCorner_"+hMc._name)._visible = !hMc._visible ;
	}
	var mc = _gHelpGetParent() ;
	if (hName == undefined) {
		for (var i in mc) {
			var hMc=eval("mc."+i);
			if( hMc._name.substring(0,5)=="ohlp_") _gHlpDisable(hMc) ;			
		}
	} else {
		var hMc = eval("mc.ohlp_"+hName) ;
		_gHlpDisable(hMc) ;		
	}
	delete _gHelpDisable ;
}

_global._gHlpAddEvent= function (mc,mcTarget) {	
			_gHelpSetHelpy(_gGetParam().helpy) ;
			_gHelpSetVoice(_gGetParam().Voice) ;
			for (var i in mc) {				
				var hMc=eval("mc."+i);
				if ( (typeof hMc) == 'movieclip') {					
					if( hMc._name.substring(0,5)=="ohlp_") {						
						_gHelpSetVars(mcTarget,mc) ;						
						hMc.hName = hMc._name.substring(hMc._name.indexOf("_")+1);	
						if ( _gHelpGetParam(hMc.hName).helpy && _gHelpGetHelpy() ) {
							hMc.onPress = function () {
								_gHelpLoader( this.hName,_gHelpGetTarget(),this  ) ;
							}							
							hMc._visible = true ;
						} else  {
							hMc._visible = false ;							
						}
						// ici 050515
						eval("hMc._parent.oCorner_"+hMc._name)._visible = !hMc._visible ;
					}
				}
			}
		}

///////////////////////////////////////////////////////////////////////////////////////////
//        Help package :
///////////////////////////////////////////////////////////////////////////////////////////
//              helpSet() is used to build _Global.help with parameters 
//						  of all the assistants.	
///////////////////////////////////////////////////////////////////////////////////////////

// Gets & sets
_global._gHelpGetHelpy = function () {
	return _gHelpHelpy ;
}
_global._gHelpGetVoice = function () {
	return _gHelpVoice ;
}
_global._gHelpGetTarget = function () {
	return _gHelpTarget ;
}

_global._gHelpGetParent = function () {
	return _gHelpParent ;
}
_global._gHelpGetNivel = function () {
	return _gHelpNivel  ;
}
_global._gHelpGet_uDisplay = function (bool) {
	return _gHelp_uDisplay ;
	
}
_global._gHelpSet_uDisplay = function (bool) {
	_global._gHelp_uDisplay = bool ;
	
}
_global._gHelpSetHelpy = function (bool) {
	_global._gHelpHelpy = bool ;
}
_global._gHelpSetVoice = function (bool) {
	_global._gHelpVoice = bool ;
}
_global._gHelpSetTarget = function (mcTarget) {
	_global._gHelpTarget = mcTarget;
}

_global._gHelpSetParent = function (mc) {
	_global._gHelpParent = mc ;
}
_global._gHelpSetNivel = function (niv) {
	_global._gHelpNivel = niv ;
}
_global._gHelpSetVars = function (mcTarget,mc) {
	_gHelpSetTarget(mcTarget) ;
	_gHelpSetNivel (mc.getDepth() + 1) ;
}
// Get help parameters object
_global._gHelpGetParam = function (hName) {	
	for (var i in _gHelp) {
		if (_gHelp[i].id == hName) return _gHelp[i] ;
	}
	return undefined ;
}
// Set general Help datas 
_global._gHelpSet = function (labels,winXY,hlpy,voice) {
		// _gHelpHelpy & _gHelpVoice is equal to true if help is activate
		// inverse logical with the checkBoxes
		_gHelpSetHelpy(hlpy);		
		_gHelpSetVoice(voice); 
		
		/////////////////////////////////////////////
		if (_gHelp == undefined) _global._gHelp = new Array() ;			
		_gHelp = labels ;
		for (var i in winXY) {
			_gHelp[i].winx = winXY[i].winx ;
			_gHelp[i].winy = winXY[i].winy ;
				_gHelp[i].helpy = true ;
				_gHelp[i].voice = true ;
		}
		
}
// Assign help window loader's labels
_global._gHelpDisplay = function () {
	// labels	
	_gHelp_aWindow.olabel_helpy1.text = _gHelpGetParam("label_helpy1").helptitle ;
	_gHelp_aWindow.olabel_helpy.text = _gHelpGetParam("label_helpy").helptitle ;
	_gHelp_aWindow.olabel_voice1.text = _gHelpGetParam("label_voice1").helptitle ;
	_gHelp_aWindow.olabel_voice.text = _gHelpGetParam("label_voice").helptitle ;
	_gHelp_aWindow.olabel_close.text = _gHelpGetParam("label_close").helptitle ;	
	// datas	
	_gHelp_aWindow.ohelpy1.setValue(!_gHelpCurrent.helpy );
	_gHelp_aWindow.ohelpy.setValue(!_gHelpHelpy);
	_gHelp_aWindow.ovoice1.setValue(!_gHelpCurrent.voice );
	_gHelp_aWindow.ovoice.setValue(!_gHelpVoice);
	// help title	
	_gHelp_aWindow.otx_helpTitle.text = _gHelpCurrent.helptitle ; ;
	_global._gHelpHandlerOn = true ;
	_gHelpSet_uDisplay(false) ;
}

_global._gHelpCheckBoxHandler = function (compo) {
	var val = compo.getValue();	
	if(_gHelpHandlerOn) {
		_global._gHelpCurrent.helpy = !_gHelp_aWindow.oHelpy1.getValue() ;
		_global._gHelpCurrent.voice = !_gHelp_aWindow.oVoice1.getValue() ;
		_gHelpSetHelpy(!_gHelp_aWindow.oHelpy.getValue() );	
		_gHelpSetVoice(!_gHelp_aWindow.oVoice.getValue() );
		if ( (!_gHelpVoice) || (!_gHelpCurrent.Voice)  )  _gDeleteSound() ;
		else {
			var nf = "./help/voice/"+_gGetParam().language+"/"+_gHelpCurrent.id+".mp3" ;
			_gPlaySound(nf);
		}
	}	
	if (!_gHelpVoice ) {
		_gHelp_aWindow.oVoice1Gray._visible = true ;		
	} else {
		_gHelp_aWindow.oVoice1Gray._visible = false ;
	}
	
	if ( (!_gHelpHelpy) && (!_gHelp_uDisplay) )  _gHelp_aWindow.oclose.onRelease() ;
	else {		
		if ((!_gHelpCurrent.helpy) && (!_gHelp_uDisplay)) _gHelp_aWindow.oclose.onRelease() ;
	}
	
	
		
}
// Call the help window loader
_global._gHelpLoader = function (hName,target,button) {		
    _gHelpSetParent(button._parent);
	button.onPress =  function () {		
		this.onPress = function () {
			_gHelpLoader( this.hName,_gHelpGetTarget(),this  ) ; 
		} ;
		_gHelpClose () ; 
	} ; 
	_global._gHelpCurrent = new Object( _gHelpGetParam(hName) );
	_global._gHelpHandlerOn = undefined ;
	_gHelp_aWindow.oclose.onRelease() ;
	target.attachMovie("helpLoader","aHelpLoader",_gHelpGetNivel());
	_gHelp_aWindow = eval("target.aHelpLoader");
	_gHelp_aWindow._x = _gHelpCurrent.winx ;
	_gHelp_aWindow._y = _gHelpCurrent.winy ;
	_gHelp_aWindow.oclose.button = button ;	 
	//// Single way to close help window ////
	_gHelp_aWindow.oclose.onRelease = function() {		
		_gHelpOnEnd (_gHelpCurrent) ;
		_gDeleteSound();
		this.button.onPress = function () {
			_gHelpLoader( this.hName,_gHelpGetTarget(),this  ) ; 
		} ;
		this._parent.removeMovieClip();		
	}
	_gHelp_aWindow.oclose.beButton("over", "out", "over") ;
	_root.createEmptyMovieClip("eX",_level0.getNextFreeDepth()) ;
	_root.eX.onEnterFrame = function () {
		_gHelpDisplay() ;
		this.removeMovieClip() ;
	}
	// drag it
	_gHelp_aWindow.oBar.onPress = function () {
			this._parent.startDrag();
			
		}
	_gHelp_aWindow.oBar.onRelease = function () {
		this._parent.stopDrag();
	}
	
	// load assistant movieClip
	_gHelp_aWindow.onComplete = function (ok) {							
		if (ok) {
			this.Mc._x = 5 ;
			this.Mc._y = 60 ;
			this.ohlpBack._width = this.Mc._x*4 + this.Mc._width ;
			this.ohlpBack._height = this.Mc._y + this.Mc._height ;		
		} else {
			this.otx_helpTitle.text = "No help available" ;
		}
	}	
	var lg = _gGetParam().language ;
	///////// Temporaly /////////////////
	if (lg!="fr" && lg!="it") lg="en" ; /////////////
	/////////////////////////////////////
	var nf = "./help/swf/"+lg+"/"+hName+".swf" ;
	_gHelp_aWindow.loadMc(nf,false) ;
	//_gGauge(_gHelp_aWindow.Mc,labels.gge1help);
	
	// Sound loading and play
	var nf = "./help/voice/"+_gGetParam().language+"/"+hName+".mp3" ;
	if ( (_gHelpVoice) && (_gHelpCurrent.voice) )  _gPlaySound(nf,false);
}
// Close the help window loader
_global._gHelpClose = function () {
	_gHelp_aWindow.oclose.onRelease() ;
}
///////////////////////////////////////////////////////////////////////////////////////////
//        END HELP package :
///////////////////////////////////////////////////////////////////////////////////////////






///////////////////////////////////////////////////////////////////////////////////////////
//        Gauge package :
///////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////
//              _gGaugeLaunch() 
///////////////////////////////////////////////////////////////////////////////////////////

/* 
// Calling example for  _gGaugeLaunch() 
// object loaded :
this.loadMc("loaded.swf") ;
// a function for the end's event :
function func () {
	// this._parent will be equal to the empty outer Gauge's Clip
	this._parent.removeMovieClip();
}
// the target (it's not absolutly necessary to create an empty MC)
this.createEmptyMovieClip("eGauge",this.getNextFreeDepth())
// Launch with params : 
//              loaded object,gauge's target,endLoadFunc,gauge's movieClip,_x & _y positions
_gGaugeLaunch(this.Mc,this.eGauge,func,"./gaugeClip.swf",Stage.width/4-70, Stage.height/4 -100) ;
*/
_global._gGaugeLaunch = function (loadedObj,target,endFunc,gaugeClip,X,Y,gaugeTitle) {	
			
			target.loadedObj = loadedObj ;
			target.gaugeTitle = gaugeTitle ;
			target.onComplete = function (){	
				if (X != undefined) {
					if (Y == undefined) Y= X;		
					this._x = X - this.Mc._width; 
					this._y = Y  - this.Mc._height; ;
				
				}
				this.Mc.loadedObj = this.loadedObj ;
				this.Mc.onEnd = endFunc ;
				this.Mc.go = _gGaugeFunc ;
				this.Mc.loadedObj.onGaugeIsStarted() ;
				this.Mc.go(this.gaugeTitle) ;
			}
			target.loadMc(gaugeClip) ;
			// Other possibility : target.attachMovie("gauge","Mc",1) ;
}

///////////////////////////////////////////////////////////////////////////////////////////
//              _gGaugeFunc() 
//					assigned to the gauge externe clip gaugeClip.swf
///////////////////////////////////////////////////////////////////////////////////////////
_global._gGaugeFunc = function  (gaugeTitle) {

	////////////////////////////////////////////////////
	// vars to be assigned before 
	// this.loadedObj = loaded clip , xml , sound ...etc
	// this.onEnd = action after loading	
	////////////////////////////////////////////////////
	
	this.gaugeTitle = gaugeTitle ;
	if (this.onEnd ==  undefined) {
		this.onEnd = function () {
			this._parent.removeMovieClip();		
		}
	}
	if (this.loadedObj == undefined ) {
		_gAlert("Loaded Object is missing",10,10,100);
	}

	this._visible = false ;
	this.otx._visible = false ;
	this.otx_title._visible = false ;
	this.otx_100._visible = false ;
	this.oclip.play() ;	
	this.onEnterFrame = function() {
		if (this.currClip == undefined) {
			this.currClip = 0 ;
			this.currGauge = 0 ;
		}
		
		this.total    =  this.loadedObj.getBytesTotal() ; //this.total    = 50;//
		this.already  =  this.loadedObj.getBytesLoaded() ; // this.already  += 1;//
		
		if (this.currClip>=100) {
			// finish...
			delete this.onEnterFrame ;
			this.oclip.play() ;			
			var step = -20; var end = 0 ;
			this.onEndFadeInOut = function () {
				this.onEnd() ;
			}
			this.fadeInOut(step,end);
			
		} else {
			 
			this._visible = true ;
			this.otx._visible = true;
			this.otx_100._visible = true ;	
			this.otx_title._visible = true ;
			this.otx_title.text = this.gaugeTitle ;
			this.otx_load.text = labels.ggeLoad ;
			if (labels.ggeLoad == undefined) this.otx_load.text = "loading..." ;
			
			if (this.already == undefined || this.already < 1 ) this.already = 1 ;
			if (this.total == undefined || this.total < 1 ) this.total = this.already * 2 ;
			this.currClip = Math.floor( ( this.already / this.total )  * 100 ) ;
			this.currGauge = Math.floor( ( this.oclip._currentframe / this.oclip._totalframes) * 100  ) ;

			
			if ( (this.currClip>=this.currGauge) || (this.currClip==1) ) {
				this.oclip.play();
			}  else {
				this.oclip.stop() ;					
			}
			if (this.oclip._currentframe == this.oclip._totalframes ) this.oclip.gotoAndStop(1);			
			
		}
	}

}
// END of function _gGaugeFunc () {
	
///////////////////////////////////////////////////////////////////////////////////////////	
//              _gGauge() : basic model call
///////////////////////////////////////////////////////////////////////////////////////////
_global._gGauge = function (loadedObj,gaugeTitle,pos) {	
	var Y =190 ;
	if (pos==2) Y+=-140 ;
	else if (pos==3) Y+=140 ;
	var parentTarget = _root ;
	var niv = parentTarget.getNextFreeDepth() ;
	parentTarget.createEmptyMovieClip("eGauge"+niv,niv) ;	
	// Launch Gauge : _gGaugeLaunch(loadObj,GaugeParent,endFunc,gauge.swf,_x, _y,title);
	_gGaugeLaunch(loadedObj,eval("parentTarget.eGauge"+niv),undefined,"./gauge/gaugeClip.swf",400,Y,gaugeTitle) ; // Stage.width/3,Stage.height/3,gaugeTitle,17) ;
}

///////////////////////////////////////////////////////////////////////////////////////////
//        END Gauge package :
///////////////////////////////////////////////////////////////////////////////////////////



//////////////////////////////////////////////////////////////////////////
// 					multimedia managing _Global class		    		//
//////////////////////////////////////////////////////////////////////////
// constructor
function ScriptXmedia(mc,arr,fld,user_id,basename) {	
	this.mc = mc ;
	this.tXmedia = arr ;
	this.fld = fld ;
	this.user_id = user_id ;
	this.basename = basename ;
	this.isXmedia = this.isItXmedia() ;
	this.cst = new Object();
	this.cst.vshift = 40 ; this.cst.xborder = 16 ; 
	this.cst.between = 10 ; this.cst.lim = .60;
	this.cst.flvBuf = 3 ; this.cst.maxChr=48 ; this.cst.maxRightChr = 40 ; this.cst.maxLeftChr = 6 ;
}
_global.scriptXmedia = ScriptXmedia ;
// Private
ScriptXmedia.prototype.setDisplay_type = function(typ) {
	this.display_type = typ  ;	
};
ScriptXmedia.prototype.setXmedia_type = function(typ) {
	this.xMedia_type = typ  ;	
};
ScriptXmedia.prototype.getXmedia_type = function() {
	return this.xMedia_type ;
};
ScriptXmedia.prototype.returnPath = function(xm) {
	var xpath="./";
	if (xm.xMedia_root.isSetAndNotNull() ) xpath += xm.xmedia_root+"/" ;
	if (xm.xMedia_root.isSetAndNotNull() && ( xm.xMedia_root.indexOf("//") > -1 ) ) xpath = xm.xmedia_root+"/" ;
	if ( this.fld.indexOf("//") > -1  ||
		 this.fld.indexOf("/")  == 0  ||
		 this.fld.indexOf("./") == 0  ||
		 this.fld.indexOf("@")  > -1 	 ) {
			return "" ;		
	} else {
		if (xm.base_prefix.toUpperCase() == "Y") xpath += xm.basename+"/" ;
		if (xm.user_prefix.toUpperCase() == "Y") xpath += xm.user_id+"/" ;
	}	
	return xpath+xm.xmedia_url+"/" ;
}

ScriptXmedia.prototype.returnURL = function() {
	// Match for this user and this base : 
	for(var i in this.tXmedia) {
		var xm = this.tXmedia[i] ;
		var f = this.fld ; var mt = xm.xmedia_type ;		
		if ( ("."+mt) == f.substring(f.length-(mt.length+1),f.length)   ) {
			if ( (xm.basename == this.basename) && (xm.user_id == this.user_id) ) return this.returnPath(xm)+this.fld  ;	
		}
	}
	// for this user and all bases : 
	for(var i in this.tXmedia) {
		var xm = this.tXmedia[i] ;
		var f = this.fld ; var mt = xm.xmedia_type ;
		if ( ("."+mt) == f.substring(f.length-(mt.length+1),f.length)   ) {	
			if ( (xm.basename == "" ) && (xm.user_id == this.user_id ) ) return this.returnPath(xm)+this.fld  ;	
		}
	}
	// for this base and all users : 
	for(var i in this.tXmedia) {
		var xm = this.tXmedia[i] ;
		var f = this.fld ; var mt = xm.xmedia_type ;
		if ( ("."+mt) == f.substring(f.length-(mt.length+1),f.length)   ) {	
			if ( (xm.basename == this.basename ) && (xm.user_id == "" ) ) return this.returnPath(xm)+this.fld  ;	
			
		}
	}
	// for all users and all bases : 
	for(var i in this.tXmedia) {
		var xm = this.tXmedia[i] ; var f = this.fld ; var mt = xm.xmedia_type ;		
		if ( ("."+mt) == f.substring(f.length-(mt.length+1),f.length)   ) {
			if ( (xm.basename == "" ) && (xm.user_id == "" ) ) return this.returnPath(xm)+this.fld  ;	
			
			
		}
	}
	return undefined ;				
};
ScriptXmedia.prototype.returnShortURL = function() {
	var str = this.returnUrl();
	if (str.length > this.cst.maxChr) {
		return str.substring(0,this.cst.maxLeftChr)+"[...]"+ str.substring(str.length - this.cst.maxRightChr);
	} else return str ;
}
// Public 
ScriptXmedia.prototype.isItXmedia = function() {
	var isXmedia = false ;
	this.setXmedia_type("");
	this.setDisplay_type("");
	for(var i in this.tXmedia) {
		var xm = this.tXmedia[i] ;
		var f = this.fld ; var mt = xm.xmedia_type ;
		if ( ("."+mt) == f.substring(f.length-(mt.length+1),f.length)   ) {	
			if ( this.getXmedia_type().length<mt.length ) {
				this.setDisplay_type (xm.display_type) ;	
				this.setXmedia_type (mt);
			}			
			if ( xm.basename == "" || xm.basename == this.basename ) {
				if (xm.user_id == "" || xm.user_id == this.user_id) {
					var isXmedia = true ;
				}
			}
		}
	}
	if (not _gGetparam().xMedia ) isXmedia = false ;
	if (this.fld.substring(0,7)=="rtmp://") isXmedia=true ;
	return isXmedia  ;	
};
ScriptXmedia.prototype.getDisplay_type = function() {
	return this.display_type ;
};
ScriptXmedia.prototype.setFld = function(f) {
	this.fld = f ;
};
ScriptXmedia.prototype.getFld = function() {
	return this.fld;
};
ScriptXmedia.prototype.playXmedia = function() {
	// Same function used for S (swf) and F (flv) 
	this.dragInitFunc = function () {
		this.aSwfHead.oDrag.onPress = function () {
			this.p = this._parent ;
			this.dxm = this.p._x - _root.Mc._x ;
			this.dym = this.p._y - _root.Mc._y ;
			this.dxb = this.p._x - this._parent._parent.aSwfBody._x ;
			this.dyb = this.p._y - this._parent._parent.aSwfBody._y ;			
			this.p.startDrag();
			this.onEnterFrame = function () {
				_root.Mc._x = this.p._x - this.dxm ;
				_root.Mc._y = this.p._y - this.dym ;
				this._parent._parent.aSwfBody._x = this.p._x - this.dxb ;
				this._parent._parent.aSwfBody._y = this.p._y - this.dyb ;
			}
		}
		this.aSwfHead.oDrag.onRelease = function () {			
			this.p.stopDrag();
			delete this.onEnterFrame ;
		}
	}
	this.videoInitFunc = function () {
		var nivb = _level0.getNextFreeDepth() ;		
		var bodyName = "aswfBody";//+nivb ;		
		_root.attachMovie("swfBody",bodyName,nivb) ;
		var nivh = _level0.getNextFreeDepth() ;
		var headName = "aswfHead";//+nivh ;
		_root.attachMovie("swfHead",headName,nivh) ;
		this.aSwfBody = eval ("_root."+bodyName);
		this.aSwfHead = eval ("_root."+headName);
		this.aSwfBody._x = Stage.width/ 2 ;
		this.aSwfBody._y = Stage.height/2 + this.cst.vshift ;
		this.aSwfHead._x=this.aSwfBody._x;
		this.aSwfHead._y=this.aSwfBody._y + (this.aSwfBody._height/2) + this.cst.between ;
		this.aSwfHead.mc = this.mc ;
		this.aSwfHead.closeWin = function () {
			delete this.onEnterFrame ;
			this._parent.aSwfBody.removeMovieClip();						
			this.removeMovieClip();
			_root.Mc.mc.unloadMovie() ;
			_root.Mc.removeMovieClip();	
			NetStr.close() ;
		}
		this.aSwfHead.oClose.onRelease = function () {
			this._parent.mc.onEndPlay() ;						
		}
		this.aSwfHead.oTitle.text = "Url : "+this.returnShortURL() ;
		this.dragInitFunc() ;
	};
	// END Same function used for S (swf) and F (flv) 	
	
	// A = Audios : mp3	
	if (this.getDisplay_type() == "A" ) {				
		var nivh = _level0.getNextFreeDepth() ;
		var headName = "aswfHead"+nivh ;
		_root.attachMovie("swfHead",headName,nivh) ;
		this.aSwfHead = eval ("_root."+headName);
		var d= Math.random()*30;
		this.aSwfHead._x = Stage.width/ 2 + d ;
		this.aSwfHead._y = Stage.height/2 - d + this.cst.vshift ;
		this.aSwfHead.closeWin = function () {					
			this.removeMovieClip();
		}
		this.mc.parentObj = this ;
		this.mc.onEachFrame = function(xScale) {
			this.parentObj.aSwfHead.oLoadBar._xscale  = xScale ;
		}
		this.aSwfHead.mc = this.mc ;
		this.aSwfHead.parentObj = this ;
		this.aSwfHead.oClose.onRelease = function () {
			this._parent.mc.onEndPlay() ;	
			// In case of the MC mc dont still exist :
			this._parent.parentObj.soundId.stop() ;
			this._parent.CloseWin() ;					
		}
		this.aSwfHead.oTitle.text = "Url : "+this.returnShortURL() ;
		this.dragInitFunc() ;
		this.mc.onSoundLoaded = function (exist) {
			if (not exist) {
				this.parentObj.aSwfHead.oLoadBar._xscale  = 0 ;
				this.parentObj.aSwfHead.oTitle.text = labels.xMediaNoValidSrc ;
			}
		}
		this.mc.onEndSound = this.mc.onEndPlay ;	
		this.soundId = this.mc.playSound(this.returnURL()) ;
	}	
	// H = Html : htm, html, gif, xml, txt etc...
	if (this.getDisplay_type() == "H" ) {
		if ( this.returnURL().indexOf("@") != -1) {
			getURL("mailto:"+this.returnURL());
		} else if ( this.xMedia_type.toLowerCase()=="gif" || this.xMedia_type.toLowerCase()=="png"  )  {
			 var src:String=this.returnURL() ;
			getURL ("javascript:openPopUp('"+src+"')");
		} else {
			getURL(this.returnURL(),"_blank");
		}
		this.mc.onEndPlay() ;	

	}	
	// F = Flv : .flv Flash Video Format
	if (this.getDisplay_type() == "F" ) {		
		/*this.videoInitFunc() ;
		// FLV system		
		 var DmcConn = new NetConnection(); 
  		 DmcConn.connect(null);
		 var netStr = new NetStream(DmcConn);	
		 netStr.aSwfHead = this.aSwfHead ;
		 netStr.aSwfBody = this.aSwfBody ;
		 netStr.cst = this.cst ; netStr.parentObj = this ;
		 netStr.buffer = netStr.cst.flvBuf ;
		 netStr.onStatus = function(infoObject) {
			if (infoObject.level == "error" ) {
				this.aSwfBody.oTxt.text = labels.xMediaNoValidSrc ;
				this.aSwfBody.oTxt_err.text = infoObject.code ;
				delete this.aSwfHead.onEnterFrame ;			
			} 
		    //this.aSwfHead._x=this.aSwfBody._x;
			//this.aSwfHead._y=this.aSwfBody._y + (this.aSwfBody._height/2) + this.cst.between ;		
			if (infoObject.level == "status") {
				if (infoObject.code == "NetStream.Buffer.Empty" && !this.endVideo ) {
					netstr.setBufferTime(this.buffer);					
					this.aSwfHead.oTitle.text = labels.xMediaBuffering+ " : "+this.buffer+" ''";
					this.buffer*=3 ;
				}
				if (infoObject.code == "NetStream.Buffer.Full" ) {
					this.aSwfHead.oTitle.text = "Url : "+this.parentObj.returnShortURL() ;
					// re-sizing					
					this.aSwfBody._height = this.aSwfBody.video.height + this.cst.xborder ;
					this.aSwfBody._width  = this.aSwfBody.video.width  + this.cst.xborder ;
					this.aSwfBody._x = Stage.width/2 // ; - (this.aSwfBody._width/2);
				    this.aSwfBody._y = Stage.height/2 + this.cst.vshift ;// ; - (this.aSwfBody._height/2) + this.cst.vshift ;
					this.aSwfHead._x=this.aSwfBody._x ;
					this.aSwfHead._y=this.aSwfBody._y + (this.aSwfBody._height/2) + this.cst.between ;
				}
				if (infoObject.code == "NetStream.Play.Stop" ) {
					this.aSwfHead.oTitle.text = labels.xMediaEndOfVideo ;
					this.endVideo = true ;
					delete this.aSwfHead.onEnterFrame ;	
				}
			}
		 };	 
		 
		 this.aSwfBody.video.attachVideo(netstr);	
		 netStr.endVideo=false ;
		 netStr.play(this.returnURL());
		 this.aSwfHead.onEnterFrame = function() {
			this.oLoadBar._xscale  = (netStr.bytesLoaded / netStr.bytesTotal) *100 ;
		 }
		 */
		 var src:String="player/FLvPlayer640.php?src="+this.returnURL() ;
		getURL ("javascript:openPopUp('"+src+"')");
	}
	// S = Swf : swf, jpg  OR  V = Video : video.swf
	if (this.getDisplay_type() == "S" || this.getDisplay_type() == "V" ) {		
		this.videoInitFunc() ;
		_root.cst = this.cst ;
		_root.onComplete = function (exist) {				
			if (not exist) {
				this.aSwfBody.oTxt.text = labels.xMediaNoValidSrc ;
			} else {				
				if ( this.Mc._height >= Stage.height * this.cst.lim ) {
					this.Mc._height = Stage.height * this.cst.lim ;
					this.Mc._xscale = this.Mc._yscale ;
				}
				this.Mc._x = Stage.width/ 2 - (this.Mc._width/2);
				this.Mc._y = Stage.height/2 - (this.Mc._height/2) + this.cst.vshift ;
				this.aSwfBody._height = this.Mc._height + this.cst.xborder ; 
				this.aSwfBody._width = this.Mc._width + this.cst.xborder ;
			}
			this.aSwfHead._x=this.aSwfBody._x;
			this.aSwfHead._y=this.aSwfBody._y + (this.aSwfBody._height/2) + this.cst.between ;
			delete this.cst ;
			delete this.onComplete ;
		}
		_root.onBeginStreaming = function () {
			this.onComplete(true) ;		
		}
		if (this.getDisplay_type() == "V") var streamingPercent = .15;
		else var streamingPercent = undefined ;
		if(streamingPercent == undefined) var gauge = true ; else gauge = false ;
		_root.loadMc(this.returnURL(), gauge, streamingPercent);		
	}
	
};
ScriptXmedia.prototype.stopXmedia = function() {
	if (this.getDisplay_type() == "A" ) {		
		this.mc.deleteSound(this.soundId) ;
		this.aSwfHead.CloseWin() ;
	}
	if (this.getDisplay_type() == "S" || 
		this.getDisplay_type() == "V" ||
		this.getDisplay_type() == "F" ){		
			this.aSwfHead.CloseWin() ;
	} 
	
};

//////////////////////////////////////////////////////////////////////////
// 					END of multimedia managing _Global class							//
//////////////////////////////////////////////////////////////////////////









