﻿
// Class 'winconnex' for server's connexion window
function winconnex() {
}
winconnex.prototype = new window();
winconnex.prototype.assignLabels = function() {
	this.olabel_title.text = labels.serverTitle;
	this.olabel_askId.text = labels.serverAskId;
	this.olabel_askPwd.text = labels.serverAskPwd;
	this.olabel_serverName.text = labels.serverServerName;
	this.olabel_UniqueBase.text = labels.serverUniqueBase;
	
	this.olabel_savePwd.text = labels.serverSavePwd;
	this.oparam.olabel.text = labels.allPrecedent;
	this.olabel_saveWin.text = labels.allSaveWin;
	this.ovalid.olabel.text = labels.initValid;
};
winconnex.prototype.isDataInputValid = function() {	
	if (this.otx_login.length == 0 ) {
		this.showAlert(labels.serverAlertId);
		return false;
	} else if (this.otx_host.length == 0 ) {
		this.showAlert(labels.serverAlertHost);
		return false;	
	} else if (this.otx_unique.length > 0 && this.otx_unique.text.indexOf(".") > -1) {
		this.showAlert(labels.baseAlertDot);
		return false;
	} else return true;
};
winconnex.prototype.assignFunctionsOnEvents = function() {
	this.ovalid.onRelease = function() {
		if (this._parent.isDataInputValid()) {
			var login = this._parent.otx_login.text;
			var pass = this._parent.otx_pass.text;
			var host = this._parent.otx_host.text;
			var unique = this._parent.otx_unique.text;
			var savewin = this._parent.osavewin.getValue();
			var savepass = this._parent.osavepass.getValue() ;
			var returnToParam = false;
			this._parent.getScriptInst().onEndWinConnex(host, login, pass, returnToParam, unique, savewin, savepass);
		}
	};
	this.ovalid.bebutton("over", "out", "over");
	this.oparam.onRelease = function() {
		var login = this._parent.otx_login.text;
		var pass = this._parent.otx_pass.text;
		var host = this._parent.otx_host.text;
		var unique = this._parent.otx_unique.text;
		//ici
		var savewin = this._parent.osavewin.getValue();
		this._parent.getScriptInst().setSavePass(false);
		var returnToParam = true;
		this._parent.getScriptInst().onEndWinConnex(host, login, pass, returnToParam, unique, savewin, savepass);
	};
	this.oparam.bebutton("over", "out", "over");
	this.setEnterDefaultAction(this.ovalid);
	
};

// Init and display connect win contents
winconnex.prototype.displayContent = function() {
	var s = this.getScriptInst();
	this.otx_host.text = s.host;
	this.otx_login.text = s.login;
	this.otx_pass.text = s.pass;
	this.otx_unique.text = s.unique;
	this.osavewin.setValue(s.savewin);
	this.osavepass.setValue(s.savepass);
};
// End Class 'winconnex'