﻿
//////////////////////////////////////////////////////////////////////////
// 					Index Update script class							//
//////////////////////////////////////////////////////////////////////////
function ScriptIndex(listWinName, updWinName, parentInst) {
	this.listWinName = listWinName;
	this.updWinName = updWinName;
	this.parentInst = parentInst ;
}
Scriptindex.prototype = new SuperScriptUpd();
Scriptindex.prototype.setStateOn = function(tt) {
	if (tt!= undefined && tt.dindex.length<2) var empty = true ; else var empty = false ;
	this.aListWin.assignTitleLabel("on",empty);
	this.aListWin.putCreateButtonState("on",empty,c.maxRepeat);
};
Scriptindex.prototype.setStateOff = function(tt) {
	if (tt!= undefined &&  tt.dindex.length<2) var empty = true ; else var empty = false ;
	this.aListWin.assignTitleLabel("off",empty);
	this.aListWin.putCreateButtonState("off",empty,c.maxRepeat);
};
ScriptIndex.prototype.showElements = function(tableObj) {
	this.assignMainObjectAndArray(tfield, tableObj , this.parentInst.getCurrentChoice().name);
	
	// Attach indexs to the tables's array if this function exist (only the first call)	
	if (this.parentInst.getCurrentChoice().tableIndexs != undefined) this.attachToTables() ;
	this.alistWin.ShowElements(tableObj , c.nivIndexUpd);
	this.alistWin.doInitScrolling();
	this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.oindexs);
}


ScriptIndex.prototype.attachToTables = function() {	 	
	for (var b in tbase) {		
		for (var nt in tbase[b].table ) {
			var tableObj = tbase[b].table[nt] ;			
			tableObj.dIndex = new Array();
			var o = new Object();
			tableObj.dIndex.push(o);
			var t = tbase[b].tableIndexs[tableObj.Name] ;
			for (var i = 1; i<t.length; i++) {
				var numIndx = this.isAlreadyAssign(t[i].key_name,tableObj.dIndex);
				if (numIndx == -1) {
					// no already assign
					// Assign index part
					var o = new Object();
					o.name = t[i].key_name;
					// chr
					o.primary = (t[i].key_name == "PRIMARY");
					// bool
					o.unique = not (t[i].non_unique);
					// bool					
					o.fulltext = (t[i].comment == "FULLTEXT");
					// bool
					o.cardinality = t[i].cardinality;
					o.field = new Array();
					var of = new Object();
					o.field.push(of);
					// Number  
					tableObj.dIndex.push(o);
					numindx = tableObj.dIndex.length-1;
				}
				// assign sequence (field) part
				var of = new Object();
				of.name = t[i].column_name;
				// field name
				//of.order = field position in the table ;
				of.seq = t[i].seq_in_index;
				// sequence's order of the field in index
				of.subpart = t[i].sub_part;
				tableObj.dIndex[numindx].field.push(of);
			}
		
		}
		// delete the initial index buffer in base nivel
		delete tbase[b].tableIndexs ;
	}
	
};


// Set the choose's Field
scriptIndex.prototype.setElementChoice = function(pos) {
	this.currentElem = pos;
};
// Get the choose's Field
scriptIndex.prototype.getElementChoice = function() {
	return this.currentElem ;
};
scriptIndex.prototype.getUpdTitle = function() {
	return labels.indexUpdTitle+" "+this.currentTable.dIndex[this.getElementChoice()].name;
};
// test if index name alreadyExist
ScriptIndex.prototype.isAlreadyAssign = function(key,tt) {	
	for (var j = 1; j<tt.length; j++) {
		if (key == tt[j].name) {
			return j;
		}
	}
	return -1;
};
// end 



// create update windows 
scriptIndex.prototype.createUpdWin = function(niv) {
	this.createUpdateWin(niv, "indxupdwin", IndxUpdWin, c.wiux, c.wiuy);
};
scriptIndex.prototype.showContent = function(pos) {
	this.aUpdWin.showTitle(labels.indexDisplayTitle+" "+this.currentTable.dIndex[pos].name);
	this.aUpdWin.showContent(pos);
};
// Cancel during updating or creation
scriptIndex.prototype.cancel = function(isCreation) {
	if (isCreation) {
		this.currentTable.dIndex = this.tBackIndex.slice(0);
		if (this.getElementChoice() == 0 || this.getElementChoice() == undefined) {
			this.closeUpdWin();
		}
	} else {
		this.currentTable.dIndex[this.getElementChoice()].field = this.tBackIndex.slice(0);
	}
	delete this.tBackIndex;
	this.setUpdWinState("show", "", 0);
};
scriptIndex.prototype.returnDatasFromInput = function(choosed) {
	var ti = this.currentTable.dIndex[choosed];
	// type d'index	
	ti.unique = this.aUpdWin.oUnique.getState();
	ti.index = this.aUpdWin.oIndex.getState();
	ti.primary = this.aUpdWin.oPrimary.getState();
	ti.fullText = this.aUpdWin.oFullText.getState();
	return ti;
};

scriptIndex.prototype.organizeRequest = function(temp, isCreation) {
	var typ = this.returnIndxTypeString(temp, true);
	// upper case	
	var req = "ALTER TABLE "+this.currentTable.name;
	if (temp.primary) {
		if (not isCreation) {
			req += " DROP PRIMARY KEY , ";
		}
		req += " ADD PRIMARY KEY (";
	} else {
		if (not isCreation) {
			req += " DROP INDEX "+temp.name+",";
		}
		req += " ADD "+typ+" "+temp.name+" (";
	}
	var t = temp.field;
	for (var i = 1; i<t.length; i++) {
		if (i>1) {
			req += " , ";
		}
		req += " "+t[i].name+" ";
		if (t[i].subpart>0) {
			req += "("+t[i].subpart+")";
		}
	}
	req += " ) ";
	req += ";";
	return req;
};
// onEndWinCreate is called in wincreate class  
scriptIndex.prototype.onEndWinCreate = function(valid, Name , typeIndx) {
			if (!valid) {
				this.aUpdWin.restoreEvents();
				this.closeWinCreate();
				this.setUpdWinState("show", "", 0);
				if (this.getElementChoice() == 0 || this.getElementChoice() == undefined) {
					this.closeUpdWin();
				} 
			} else {
				//  var name is the choosed name by user
				if (this.isAlreadyAssign(name)>0) {
					this.showAlert(labels.indexAlertExist);
					return;
				}
				this.currentTable.defaultInput = name;
				this.aUpdWin.restoreEvents();
				this.closeWinCreate();
				if (this.currentTable.dIndex == undefined) {
					this.currentTable.dindex = new Array();
					var o = new Object();
					this.currentTable.dIndex.push(o);
					this.setElementChoice(0);
				}
				this.tBackIndex = new Array();
				var t = this.currentTable.dIndex;
				this.tBackIndex = this.currentTable.dIndex.slice(0);
				// Assign new index
				var o = new Object();
				o.Name = Name;
				if (Name.toUpperCase() == "PRIMARY") {
					o.primary = true;
					o.index = false;
				} else {
					o.primary = false;
					o.index = true;
				}
				o.unique   = (typeIndx == "UNIQUE") ;
				o.fulltext = (typeIndx == "FULLTEXT") ;
				o.cardinality = 0;
				// init sequence (field) part
				o.field = new Array();
				var of = new Object();
				o.field.push(of);
				t.push(o);
				numindx = t.length-1;
				this.setCurrentCreated(numindx);
				// display title with index name				
				this.aUpdWin.showTitle(labels.indexCreateTitle+" : "+t[numindx].name);
				var mc = this.aUpdWin.ocompo.getScrollContent();
				// common setup to prepare update OR create
				this.aUpdWin.setupdCrea(t[numindx].field, numindx, mc);
				return t[numindx].field ; // used by calling methods wich have to update
			}
}

//
// Write to sql base, the current updated/created index 
scriptIndex.prototype.writeElement = function(isCreation) {
	this.onEnd = function() {
		delete this.tBackIndex;
		this.alistWin.ShowElements(undefined, c.nivIndexUpd);
		this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.oindexs);
		this.setUpdWinState("show", "", 0);
		delete this.onEnd;
	};
	this.aUpdWin.disableEventsAndGray();
	if (isCreation) {
		var choosed = this.getCurrentCreated();
	} else {
		var choosed = this.getElementChoice();
	}
	var temp = this.returnDatasFromInput(choosed);
	scriptInstance = this;
	this.newSendPhp();
	sendphp.req = this.organizeRequest(temp, isCreation);
	//---
	receivephp = new LoadVars();
	receivephp.onLoad = function() {
		if (this.state != "ok") {			
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();
			};
			scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);
		} else {
			if (isCreation) {
				var txt = labels.indexCreateOk;
			} else {
				var txt = labels.indexUpdateOk;
			}
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();				
				this.onEnd();
			};
			scriptInstance.showAlert(txt+" '"+temp.name+"' "+labels.allOk, "",scriptInstance);			
		}
	};
	sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
};
scriptIndex.prototype.writeUpdatedElement = function() {
	this.writeElement(false);
};
scriptIndex.prototype.writeCreatedElement = function() {
	this.writeElement(true);
};
// Write to sql base, the current deleted index 
scriptIndex.prototype.deleteElement = function() {
	this.onEndWinDelete = function(valid) {
		if (!valid) {
			this.aUpdWin.restoreEvents();
			this.closeWinDelete();
		} else {
			// end of deleting is there
			this.onEnd = function() {
				this.currentTable.dIndex.splice(this.getElementChoice(), 1);
				if (this.currentTable.dIndex.length>1) {
					this.setElementChoice(1);
				}
				this.alistWin.ShowElements(undefined, c.nivIndexUpd);
				this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.oindexs);
				this.setUpdWinState("show", "", 0);
				delete scriptInstance.onEnd;
				delete scriptInstance.onEndWinDelete;
			};
			this.currentTable.dIndex[this.getElementChoice()];
			var temp = this.currentTable.dIndex[this.getElementChoice()];
			scriptInstance = this;
			this.newSendPhp();
			if (temp.primary) {
				var str = " DROP PRIMARY KEY ";
			} else {
				var str = " DROP INDEX "+temp.name;
			}
			sendphp.req = "ALTER TABLE "+this.currentTable.name+str;
			receivephp = new LoadVars();
			receivephp.onLoad = function() {
				if (this.state != "ok") {
					scriptInstance.onEndAlert = function() {
						this.aUpdWin.restoreEvents();
					};					
					scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);
				} else {
					scriptInstance.closeWinDelete();
					scriptInstance.onEndAlert = function() {
						this.aUpdWin.restoreEvents();
						this.onEnd();
					};
					scriptInstance.showAlert(labels.indexCreateDeleteOk1+" '"+temp.name+"' "+labels.allDeleteOk1, "",scriptInstance);
					
				}
			};
			// receivephp.onLoad  = function () {
			sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
		}
		// if (!valid) {		
	};
	// onEndwinDelete
	this.aUpdWin.disableEventsAndGray();
	var name = this.currentTable.dIndex[this.getElementChoice()].name;
	this.createWinDelete(c.nivDelete, labels.indexElemDeleteConfirm, underIsVisible, name);
};
//////////////////////////////////////////////////////////////////////////
// 					END Index Update script class						//
//////////////////////////////////////////////////////////////////////////
