﻿//////////////////////////////////////////////////////////////////////////
// 					Datas Update script class							//
//////////////////////////////////////////////////////////////////////////
function ScriptDatasUpd(listWinName, updWinName, sortWinName, buttonsWinName, parentInst) {
	this.listWinName = listWinName;
	this.updWinName = updWinName;
	this.sortWinName = sortWinName;
	this.buttonsWinName = buttonsWinName;
	this.parentInst = parentInst ; // instance of scriptTable classe
	this.mustReadDatas = true;
}
ScriptDatasUpd.prototype = new SuperScriptUpd();

ScriptDatasUpd.prototype.ReturnToDescription = function() {
	if (this.mustReadDatas) {
		this.closeButtonsWin();
		this.closeSortWin();
		this.closeWin();
		// List Win + upd win
	} else {
		this.inVisibleDatasWindows();
	}
	this.visibleDescripWindows();
};
ScriptDatasUpd.prototype.go = function(tfieldArray, currentTableArray, baseName) {
	this.init = init;
	// False only if table or fields description are not changed since the last call
	this.assignMainObjectAndArray(tfieldArray, currentTableArray, basename);
	// init sort/sel description Array 
	if (this.currentTable.dSort == undefined) {
		this.initSortArray();
	}
	if (this.mustReadDatas) {
		// Clear current element's choice 
		this.setElementChoice();
		this.closeUpdWin();
		// Create (empty) datas's list window 
		this.createWin(c.nivDataList, "listwin", listwin, c.wdlx, c.wdly);
		// Create generic buttons window  
		this.createButtonsWin();
		// Open sort win :
		this.alistWin.osort.onRelease();
		//change "return to description" button
		this.abuttonsWin.changeEventToReturn(this);
	} else {
		this.VisibleDatasWindows();
	}
};
// initalization of sort/sel description Arrays (attached to this.currentTable)
ScriptDatasUpd.prototype.initSortArray = function() {
	this.currentTable.dSort = new Array();
	// first sort with first field
	var o = new Object();
	o.field = this.currentTable.field[1].name;
	o.indx = 1;
	o.ascDesc = true;
	// Ascending
	this.currentTable.dSort[1] = o;
	// next sort with none
	var o = new Object();
	o.field = "< "+labels.allNone+" >";
	o.indx = 0;
	o.ascDesc = true;
	// Ascending
	this.currentTable.dSort[2] = o;
	var o = new Object();
	o.field = "< "+labels.allNone+" >";
	o.indx = 0;
	o.ascDesc = true;
	// Ascending
	this.currentTable.dSort[3] = o;
	// No selection 
	this.currentTable.dSel = "";
};
ScriptDatasUpd.prototype.createSortWin = function() {
	Object.registerClass("sortWin", sortWin);
	eval(this.sortWinName).removeMovieClip();
	attachMovie("sortWin", this.sortWinName, c.nivDatasSort);
	this.aSortWin = eval(this.sortWinName);
	this.aSortWin.setPosCenter();
	this.aSortWin.setScriptInst(this);
	this.disableDatasWindows();
	this.aSortWin.assignLabels(this.currentTable.name);
	this.aSortWin.OnEndFieldsComboAssign = function() {
		// Assign sort combos and sel with last choosed values
		this.assignCurrentValues();
		this.setButtonsState();
		delete this.OnEndFieldsComboAssign;
	};
	this.aSortWin.counter = 0;
	this.aSortWin.fieldsComboAssign(this.currentTable, this.aSortWin.ocombofield1, false);
	this.aSortWin.fieldsComboAssign(this.currentTable, this.aSortWin.ocombofield2, true);
	this.aSortWin.fieldsComboAssign(this.currentTable, this.aSortWin.ocombofield3, true);
	this.aSortWin.fieldsComboAssign(this.currentTable, this.aSortWin.ocombofield, true);
	this.aSortWin.assignFunctionsOnEvents();
	this.aSortWin.doFlashEffect();
	this.sortWinIsCreate = true;
};
// when return from sort win (cancel or valid)
ScriptDatasUpd.prototype.endSortWin = function(valid) {
	if (valid) {
		// Valid button released
		// read datas from MySql
		this.readDatas();
		this.setElementChoice(undefined);
	} else {
		// Cancel button released
		if (this.mustReadDatas) {
			this.returnToDescription();
		}
	}
	this.closeSortWin();
};
ScriptDatasUpd.prototype.closeSortWin = function() {
	this.sortwinIsCreate = false;
	this.aSortWin.closeWin();
	// enable others under windows
	this.restoreDatasWindows();
};
////////////// Data's generic buttons Window
ScriptDatasUpd.prototype.createButtonsWin = function() {
	Object.registerClass("dataButtonsWin", dataButtonsWin);
	eval(this.buttonsWinName).removeMovieClip();
	attachMovie("dataButtonsWin", "aDataButtonsWin", c.nivDataButtons);
	this.aButtonsWin = eval(this.buttonsWinName);
	this.aButtonsWin.setPos(c.wdbx, c.wdby);
	this.aButtonsWin.setScriptInst(this);
	this.aButtonsWin.assignLabels();
	this.aButtonsWin.assignFunctionsOnEvents(this);
	this.ButtonsWinIsCreate = true;
};
ScriptDatasUpd.prototype.isButtonsWinCreate = function() {
	return this.ButtonsWinIsCreate;
};
ScriptDatasUpd.prototype.closeButtonsWin = function() {
	this.ButtonsWinIsCreate = false;
	this.aButtonsWin.closeWin();
};
////////////////////////////////////////////////////////
ScriptDatasUpd.prototype.initSql = function() {
	// Create ScriptSelSql instance
	if (selectSql == undefined) selectSql = new ScriptSelSql("aSelSqlwin", this.aButtonWin, this);	
	
	// normal button action become close button	
	this.onEndDisableDatasWin = function () {		
		this.aButtonsWin.changeEventToReturn(selectSql);	
	}
	if ( this.isUpdWinCreate() ) {
		this.aButtonsWin.disableEventsAndGray();	
		this.aUpdWin.onEndMove = function () {			
			this.getScriptInst().disableDatasWindows();		
			delete this.onEndMove ;
		}
		this.aUpdWin.moveToLocation(1, this.aUpdWin._width*1.50, 0, 0, false, 0, .5, ma);
	} else this.disableDatasWindows();
	
	// Go to import and user sql resquest :
	// 	Fields description's array = tfield
	//	Choosed table with its fields names's array  = field.getCurrentChoice()
	//  The baseName of the choosed table  = table.getCurrentChoice().name
	selectSql.go(tfield, field.getCurrentChoice(), table.getCurrentChoice().name);
};
////////////////////////////////////////////////////////
ScriptDatasUpd.prototype.initExport = function() {
	// Create ScriptSelSql instance
	if (export == undefined) export = new ScriptExport("aExportWin", this.aButtonWin, this);
	// normal button action become close button	
	this.onEndDisableDatasWin = function () {		
		this.aButtonsWin.changeEventToReturn(export);	
	}
	if ( this.isUpdWinCreate() ) {
		this.aButtonsWin.disableEventsAndGray();	
		this.aUpdWin.onEndMove = function () {			
			this.getScriptInst().disableDatasWindows();		
			delete this.onEndMove ;
		}
		this.aUpdWin.moveToLocation(1, this.aUpdWin._width*1.50, 0, 0, false, 0, .5, ma);
	} else this.disableDatasWindows();
	// Go to datas's Exportation :
	// 	Fields description's array = tfield
	//	Choosed table with its fields names's array  = field.getCurrentChoice()
	//  The baseName of the choosed table  = table.getCurrentChoice().name
	export.go(tfield, field.getCurrentChoice(), table.getCurrentChoice().name);
};
////////////////////////////////////////////////////////
// Organize request from sort and sel arrays
ScriptDatasUpd.prototype.organizeRequest = function(currLine) {
	var req = new String();
	req = "SELECT * ";
	req += "FROM "+this.currentTable.name+" ";
	if (this.currentTable.dSel != "") {
		req += "WHERE "+this.currentTable.dSel+" ";
	}
	if (this.currentTable.dSort[1].indx != 0) {
		req += " ORDER BY "+this.currentTable.dSort[1].field;
		if (this.currentTable.dSort[1].ascDesc) {
			req += " ASC ";
		} else {
			req += " DESC ";
		}
		if (this.currentTable.dSort[2].indx != 0) {
			req += ", "+this.currentTable.dSort[2].field;
			if (this.currentTable.dSort[2].ascDesc) {
				req += " ASC ";
			} else {
				req += " DESC ";
			}
		}
		if (this.currentTable.dSort[3].indx != 0) {
			req += ", "+this.currentTable.dSort[3].field;
			//
			if (this.currentTable.dSort[3].ascDesc) {
				req += " ASC ";
			} else {
				req += " DESC ";
			}
		}
	}
	req += " LIMIT "+currLine+","+c.maxLine+" ";
	var str = req.convertXml();
	// Convert < , > , & before insert in Xml markup
	return "<REQUEST> "+str+" </REQUEST>";
	
};
// create update windows 
scriptDatasUpd.prototype.createUpdWin = function(niv) {
	this.createUpdateWin(niv, "updwin", UpdWin, c.wdux, c.wduy);
};

// read datas from MySql
// 		Datas Streaming after c.maxLine first lines reading
ScriptDatasUpd.prototype.datasStreaming = function() {
	this.onEndRead = function(tRead) {	  	
	  this.moreDatas = new Array();
	  this.moreDatas = eval("tRead."+this.currentTable.name);
	  if (this.moredatas.isSetAndNotNull()) {	
		this.datas = this.datas.concat( this.moreDatas.slice(1) );		
		//this.alistWin.ShowMoreElements(c.nivDataUpd);			//ici
		this.currLine += (c.maxLine) ;
		if (this.moredatas.length<c.maxLine+1) var cumLine = this.currLine-c.maxLine+this.moredatas.length-1;
		else var cumLine = this.currLine ;
		this.aListWin.displayStreamingMsg(cumline,c.StreamMsgDlx,c.StreamMsgDly,labels.dataStreamingMsg);
		this.read(this.organizeRequest(this.currLine));
	  } else {
		 this.aListWin.hideStreamingMsg();
		 this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.odatas);
		 this.alistWin.liftPosRefresh(this.alistWin.oLift);
		 if (this.currLine>c.maxLine) {
		 	this.showAlert(labels.dataStreamingInfos1+"\n"+labels.dataStreamingInfos2,"",this,false);	
		 }
		 delete this.onEndRead ;
	  }
	};
	this.currLine += (c.maxLine) ;
	this.aListWin.displayStreamingMsg(this.datas.length,c.StreamMsgDlx,c.StreamMsgDly,labels.dataStreamingMsg);
	if (this.datas.isSetAndNotNull()) this.read(this.organizeRequest(this.currLine));
	else this.aListWin.hideStreamingMsg();
};
// 		c.maxLine first lines reading
ScriptDatasUpd.prototype.readDatas = function() {
	this.currLine = 0 ;
	this.onEndRead = function(tRead) {
		this.datas = new Array();
		this.datas = eval("tRead."+this.currentTable.name);	
		this.aListWin.setFirstRow(1); //ici 
		this.alistWin.ShowElements(undefined, c.nivDataUpd);
		this.aListWin.doInitScrolling();
		this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.odatas);
		this.putCreateButtonState("on");
		this.MustReadDatas = false;
		this.datasStreaming() ;		
	};
	export.clearBuffers() ;	
	this.read(this.organizeRequest(this.currLine));
};
ScriptDatasUpd.prototype.setElementChoice = function(current) {
	this.currentTable.currentData = current;
};
ScriptDatasUpd.prototype.getElementChoice = function() {
	return this.currentTable.currentData;
};
ScriptDatasUpd.prototype.getUpdTitle = function() {
	return labels.dataUpdTitle+" : "+this.datas[this.currentTable.currentData][this.currentTable.dSort[1].field];
};
ScriptDatasUpd.prototype.showContent = function(pos) {
	this.aUpdWin.showTitle(labels.dataDisplayTitle+" : "+this.datas[pos][this.currentTable.dSort[1].field]);
	this.aUpdWin.showContent(this.datas[pos]);
};
ScriptDatasUpd.prototype.writeUpdatedElement = function() {
	this.writeElement(this.get_duplicate());
};
ScriptDatasUpd.prototype.writeCreatedElement = function() {
	this.writeElement(true);
};
ScriptDatasUpd.prototype.writeElement = function(isCreation) {	
	this.onEnd = function(temp, isCreation) {		
		this.screenToBuffer(temp, isCreation);
		this.alistWin.showElementsCurrent(isCreation); //ici
		//ici this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.odatas);
		this.setUpdWinState("show", "", 0);
		if (isCreation) {
			if (this.get_duplicate()) {
				this.setUpdWinState("update", this.getUpdTitle(), this.getElementChoice());
			} else if (this.get_andInsert()) {
				this.alistWin.ocreate.onRelease();
			}
		}
		delete this.onEnd;
	};
	var temp = this.returnDatasFromInput();
	var thisScript = this;
	if (this.currentTable.dindex == undefined && (!isCreation)) {
		if (index == undefined) {
			index = new ScriptIndex("aindxlistwin", "aindxupdwin");
		}
		index.onEndInitIndexsArray = function() {
			thisScript.writeElement2(temp, isCreation);
		};
		index.initIndex(this.tfield, this.currentTable, this.baseName);
	} else {
		this.writeElement2(temp, isCreation);
	}
};
ScriptDatasUpd.prototype.writeElement2 = function(temp, isCreation) {
	this.aUpdWin.disableEventsAndGray();
	this.alistwin.restoreEventLabel(labels.dataInsertButton);
	var scriptInstance = this;
	this.newSendPhp();
	sendphp.req = this.organizeUpdRequest(temp, isCreation);
	receivephp = new LoadVars();
	receivephp.onLoad = function() {
		if (this.state != "ok") {
			scriptInstance.onEndAlert = function() {
				scriptInstance.aUpdWin.restoreEvents();
			};
			scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle,scriptInstance);
		} else {
			if (isCreation) {
				var txt = labels.dataCreateOk;
			} else {
				var txt = labels.dataUpdateOk;
			}
			scriptInstance.onEndAlert = function() {
				this.aUpdWin.restoreEvents();
				this.onEnd(temp, isCreation);
			};
			scriptInstance.showAlert(txt+"  "+labels.allOk, "",scriptInstance);
			
		}
	};
	sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
};

// return datas from Input before write to mySql
ScriptDatasUpd.prototype.returnDatasFromInput = function() {
	var datas = new Object();
	var t = this.tfield;
	for (var i = 1; i<t.length; i++) {
		datas[t[i].field] = eval("this.aUpdwin.odata_upd.odatas.atxt_"+t[i].field+".otxt").text;
	}
	return datas;
};
ScriptDatasUpd.prototype.organizeUpdRequest = function(temp, isCreation) {
	if (!isCreation) {
		req = "UPDATE "+this.tableName+" SET ";
		var bool = false;
		for (var i in temp) {
			if (bool) {
				req += " , ";
			}			
			req += " "+i+" = '"+temp[i].convert_apostr("''")+"' ";
			bool = true;
		}
		req += this.returnUpdWhere();
	} else {
		//INSERT INTO `ordi`
		req = "INSERT INTO "+this.tableName+" ( ";
		var bool = false;
		var o = new Object();
		for (var i in temp) { o[i] = temp [i] } ;
		for (var i in o ) {
			if (bool) {
				req += " , ";
			}
			req += i;
			bool = true;
		}
		req += " ) VALUES ( ";
		var bool = false;
		for (var i in o) {
			if (bool) {
				req += " , ";
			}
			req += "'"+o[i].convert_apostr("''")+"'";
			bool = true;
		}
		req += " ) ";
	}
	req += ";";
	return req;
};
ScriptDatasUpd.prototype.returnUpdWhere = function() {
	// look for primary or unique index
	var choosed = this.getElementChoice();
	var req = "";
	var t = this.currentTable.dindex;
	var ind = undefined;
	var w = new Object();
	// fields for where clause
	for (var i = 1; i<t.length; i++) {
		if (t[i].primary || t[i].unique) {
			ind = i;
			break;
		}
	}
	if (ind != undefined) {
		var t = this.currentTable.dindex[ind].field;
		for (var i = 1; i<t.length; i++) {
			w[t[i].name] = this.datas[choosed][t[i].name];
		}
	} else {
		var t = this.tfield;
		for (var i = 1; i<t.length; i++) {
			w[t[i].field] = this.datas[choosed][t[i].field];
		}
	}
	var bool = false;
	req += "WHERE";
		
	for (var i in w) {
		if (bool) {
			req += " AND ";
		}
		req += " "+i+" = '"+w[i].convert_apostr("''")+"' ";
		bool = true;
	}
	req += " LIMIT 1";
	
	return req;
};
// Update Array buffer 'this.Datas' after write to mySql
scriptDatasUpd.prototype.screenToBuffer = function(temp, isCreation) {
	var choosed = this.getElementChoice();
	if (isCreation) {
		if (choosed == undefined) {
			choosed = 1;
		}
		if (choosed<1) {
			choosed = 1;
		}
		var o = new Object();
		if (this.datas.length < 1) this.datas.push(o) ;
		this.datas.splice(choosed, 0, o);
		
	}
	for (var i in temp) {
		this.datas[choosed][i] = temp[i];
	}
	this.setElementChoice(choosed);
	export.clearBuffers();
};
// Cancel during updating or creation
scriptDatasUpd.prototype.cancel = function(isCreation) {
	this.alistwin.restoreEventLabel(labels.dataInsertButton);
	this.setUpdWinState("show", "", 0);
};
// Write to sql base, the current deleted index 
scriptDatasUpd.prototype.deleteElement = function() {
	var name = this.datas[this.currentTable.currentData][this.currentTable.dSort[1].field];
	this.onEndWinDelete = function(valid) {
		if (!valid) {
			this.aUpdWin.restoreEvents();
			this.closeWinDelete();
		} else {
			// end of deleting is there
			this.onEnd = function() {
				this.datas.splice(this.getElementChoice(), 1);
				if (this.datas.length<1) {
					this.setElementChoice();
				}
				this.alistWin.ShowElementsCurrent(); //ici
				//ici this.alistWin.assignScrolling(this.alistWin.ohead, this.alistWin.olist.odatas);
				this.setUpdWinState("show", "", 0);
				export.clearBuffers();
				delete scriptInstance.onEnd;
				delete scriptInstance.onEndWinDelete;
			};
			scriptInstance = this;
			this.newSendPhp();
			sendphp.req = "DELETE FROM "+this.currentTable.name+" "+this.returnUpdWhere();			
			receivephp = new LoadVars();
			receivephp.onLoad = function() {
				if (this.state != "ok") {
					scriptInstance.showAlert(labels.allMySqlReturnError+" : \n"+this.err, labels.allAlertTitle);
					aWinDelete.onEndAlert = function() {
						scriptInstance.aUpdWin.restoreEvents();
					};
				} else {
					scriptInstance.closeWinDelete();
					scriptInstance.onEndAlert = function() {
						this.aUpdWin.restoreEvents();
						this.onEnd();
					};
					scriptInstance.showAlert(labels.dataCreateDeleteOk1+" '"+name+"' "+labels.allDeleteOk1, "",scriptInstance);						
				}
			};
			// receivephp.onLoad  = function () {
			sendphp.sendAndLoad("php/flashmyadmin.php", receivephp, "POST");
		}
		// if (!valid) {		
	};
	// onEndwinDelete
	this.aUpdWin.disableEventsAndGray();
	this.createWinDelete(c.nivDatasDelete, labels.dataElemDeleteConfirm, true, name);
};
